var config = {
    get_ext_options : function(f){
        chrome.storage.sync.get({
            api_key: false,
            api_root_url : false,
            stores: [],
            active_store: false,
            shippingOption: config.defaultShippingSettings.shippingOption,
            shippingCountry: config.defaultShippingSettings.shippingCountry,
            shippingCurrency: config.defaultShippingSettings.shippingCurrency,
            showShipping: !0,
            showOnlyActive: !1,
            showProcessing: !0,
            showDelivery : !0

        }, function(items) {
            f(items);
        });
    },
    defaults: {
        storedOrderTTL: 6e5,
        processingOrderTTL: 6e4,
        maxFulfilledOrders: 30,
        minPageMatchPercentage: .5,
        failedTaskPause: 150,
        chromeExtensionSource: 4,
    },
    assets: {
        svgLogo: "assets/images/logo.png",
        logoSM: "assets/images/logo-small.png",
        logoXS: "assets/images/logo-xs.png",
        iconImportSuccess: "assets/images/icon-import-success.png",
        iconImportError: "assets/images/icon-import-error.png",
        iconTime: "assets/images/icon-time.png",
        iconCheck: "assets/images/icon-check.png",
        iconClose: "assets/images/icon-close.png",
        iconCloseCircle: "assets/images/icon-close-circle.png",
        iconRemove: "assets/images/icon-x.png",
        btnFloating: "assets/images/btn-floating.png",
        iconImported: "assets/images/btn-imported.png",
    },
    urls: {
        host : "ebay.com",
        domain : ".ebay.com",
        cart : "https://cart.ebay.com",
        item : "https://www.ebay.com/itm/*",
    //    shippingInfo_old: "https://freight.aliexpress.com/ajaxFreightCalculateService.htm?productid={1}&country={2}&count={3}&currencyCode={4}",
    //    shippingInfo_old1: "https://m.aliexpress.com/freight/ajaxapi/calculate.do?productId={1}&countryCode={2}&quantity={3}&currency={4}",
    //    shippingInfo_old2: "https://freight.aliexpress.com/ajaxFreightCalculateService.htm?productid={1}&country={2}&count={3}&currencyCode={4}",
    //    shippingInfo: "https://m.aliexpress.com/api/products/{1}/fees?country={2}&minPrice=0.01&maxPrice=0.01&tradeCurrency={4}&count={3}&userScene=M_DETAIL_SHIPPING_PANEL",

    //    aliexpressLink : "https://www.aliexpress.com/",
        ebayLink : "https://www.ebay.com",
    //    orderInfo : "https://trade.aliexpress.com/order_detail.htm?orderId={1}&rrnd={2}",
    //    aliexpressPayAllLink : "https://trade.aliexpress.com/order_list.htm",
        ebayPayAllLink : "https://trade.ebay.com/order_list.htm",
    //    ebayPayAllLink : "https://cart.payments.ebay.com/",
    //    aliexpressMaintain : "https://www.aliexpress.com/maintain.html",
        ebayMaintain : "https://www.ebay.com/maintain.html",
    //    queryCountries: "https://ilogisticsaddress.aliexpress.com/AjaxQueryCountries",
    //    ordersDetail: "https://shoppingcart.aliexpress.com/api/1.0/orders.htm",
    //    ajaxSaveOrUpdateBuyerAddress: "https://ilogisticsaddress.aliexpress.com/ajaxSaveOrUpdateBuyerAddress.htm",
        ebayPaymentHost: "cart.payments.ebay.com",
        addToCart: "https://cart.payments.ebay.com/sc/add",
        ebaySingIn: "https://signin.ebay.com/ws/eBayISAPI.dll",
    //    v2AddToCart: "https://shoppingcart.aliexpress.com/addToShopcart4Js.htm",
    //    v2GetShippingMethods: "https://www.aliexpress.com/aeglodetailweb/api/logistics/freight"
        ajaxGetAddressFields:     'https://pay.ebay.com/rxo/ajax?action=getAddressFields*',
        ajaxAddAddress:           'https://pay.ebay.com/rxo/ajax?action=addAddress*',
        ajaxAddSellerMessage:     'https://pay.ebay.com/rxo/ajax?action=addSellerMessage*',
        ajaxEditShippingService:  'https://pay.ebay.com/rxo/ajax?action=editShippingService*',

        ajaxGetAddressFieldsG:    'https://pay.ebay.com/rgxo/ajax?action=getAddressFields*',
        ajaxAddAddressG:          'https://pay.ebay.com/rgxo/ajax?action=addAddress*',
        ajaxAddSellerMessageG:    'https://pay.ebay.com/rgxo/ajax?action=addSellerMessage*',
        ajaxEditShippingServiceG: 'https://pay.ebay.com/rgxo/ajax?action=editShippingService*',
    },
    actions: {
        E_SYNC_PRODUCT_LIST : "E_SYNC_PRODUCT_LIST",
        E_CONTENT_PUSH_PRODUCT_TO_APP : "E_CONTENT_PUSH_PRODUCT_TO_APP",
        E_CONTENT_DELETE_PRODUCT_FROM_APP : "E_CONTENT_DELETE_PRODUCT_FROM_APP",
        E_CONTENT_TEST_CONNECTION : "E_CONTENT_TEST_CONNECTION",
        /*
        E_CONTENT_GENERATE_AUTH_COOKIE: "E_CONTENT_GENERATE_AUTH_COOKIE",
        E_CONTENT_VALIDATE_AUTH_COOKIE: "E_CONTENT_VALIDATE_AUTH_COOKIE",
        */
        E_CONTENT_ADD_PRODUCT_TO_CART : "E_CONTENT_ADD_PRODUCT_TO_CART",
        E_CONTENT_GET_SHIPPING_METHOD : "E_CONTENT_GET_SHIPPING_METHOD",
        E_CONTENT_GET_COUNTRIES : "E_CONTENT_GET_COUNTRIES",

        E_CONTENT_OPEN_SETTING_TAB : "E_CONTENT_OPEN_SETTING_TAB",
        E_GET_PRODUCTS_SHIPPING_INFO : "E_GET_PRODUCTS_SHIPPING_INFO",
        E_CHECK_MAIN_CONTENT_IS_INCLUDED : "E_CHECK_MAIN_CONTENT_IS_INCLUDED",
        E_GET_AND_PUSH_PRODUCT_HTML_TO_APP : "E_GET_AND_PUSH_PRODUCT_HTML_TO_APP",

        E_CONTENT_GET_PRODUCT_HTML : "E_CONTENT_GET_PRODUCT_HTML",
        E_CONTENT_GET_PRODUCT_INFO : "E_CONTENT_GET_PRODUCT_INFO",

        E_CONTENT_ORDER_FULFILLMENT_QUEUE : "E_OrderFulfillmentQueue",
        E_CONTENT_ORDER_TRACKING_CODE_REQUEST : "E_CONTENT_ORDER_TRACKING_CODE_REQUEST",
        E_CONTENT_ORDER_TRACKING_CODE_RESPONSE : "E_CONTENT_ORDER_TRACKING_CODE_RESPONSE",
        E_CONTENT_ORDER_FULFILLMENT_STATUS_RESPONSE : "E_CONTENT_ORDER_FULFILLMENT_STATUS_RESPONSE",
        E_CONTENT_SET_EBAY_COOKIE : "E_CONTENT_SET_EBAY_COOKIE",
        E_CONTENT_ORDER_FULFILLMENT_TO_CART : "E_toCart",
        E_WEB_GET_PRODUCT_INFO_REQUEST : "E_WEB_GET_PRODUCT_INFO_REQUEST",


        E_WEB_GET_PRODUCT_HTML_REQUEST : "E_WEB_GET_PRODUCT_HTML_REQUEST",

        E_WEB_GET_PRODUCT_HTML_RESPONSE : "E_WEB_GET_PRODUCT_HTML_RESPONSE",
        E_WEB_GET_PRODUCT_INFO_RESPONSE : "E_WEB_GET_PRODUCT_INFO_RESPONSE",

        E_WEB_SET_EBAY_COOKIE_REQUEST : "E_WEB_SET_EBAY_COOKIE_REQUEST",
        E_WEB_SET_EBAY_COOKIE_RESPONSE : "E_WEB_SET_EBAY_COOKIE_RESPONSE",
        E_WEB_ORDER_FULFILLMENT_REQUEST : "E_order_fulfillment",
        E_WEB_ORDER_TRACKING_CODE_REQUEST : "E_order_tracking_code",
        E_WEB_ORDER_TRACKING_CODE_RESPONSE : "E_order_tracking_code_response",
        E_WEB_ORDER_FULFILLMENT_STATUS_RESPONSE : "E_order_fulfillment_status_response",
        E_CONTENT_CLEAR_ORDER_DATA : "E_CONTENT_CLEAR_ORDER_DATA",
        E_CONTENT_ORDER_FULFILLMENT_RESPONSE : "E_get_order_fulfillment_response",
        E_WEB_ORDER_FULFILLMENT_PAYALL_REQUEST : "E_order_fulfillment_payall",
        E_CONTENT_ORDER_FULFILLMENT_PAYALL_REQUEST : "E_CONTENT_ORDER_FULFILLMENT_PAYALL_REQUEST",
        E_WEB_CLOSE_CHROME_TAB_REQUEST : "E_close_chrome_tab",
        E_CONTENT_CLOSE_CHROME_TAB_REQUEST : "E_CONTENT_CLOSE_CHROME_TAB_REQUEST",
        E_WEB_SWITCH_TO_CHROME_TAB_REQUEST : "E_switch_to_chrome_tab",
        E_CONTENT_SWITCH_TO_CHROME_TAB_REQUEST : "E_SWITCH_TO_CHROME_TAB_REQUEST",
        E_CONTENT_SWITCH_TO_PLUGIN_TAB_REQUEST : "E_CONTENT_SWITCH_TO_PLUGIN_TAB_REQUEST",
        E_CONTENT_SET_ADDRESS : "E_CONTENT_SET_ADDRESS",
        E_CONTENT_TEST_REQUEST : "E_CONTENT_TEST_REQUEST",
        E_CONTENT_SET_POPUP : "E_CONTENT_SET_POPUP",
        E_CONTENT_CHECK_PRODUCTS_IMPORTED : "E_CONTENT_CHECK_PRODUCTS_IMPORTED",
        E_CONTENT_UPDATE_TAB_URL : "E_CONTENT_UPDATE_TAB_URL",
    },
    defaultShippingSettings: {
        showShipping: !0,
        shippingOption: "",
        shippingCountry: "US",
        shippingCurrency: "USD",
        showOnlyActive: !1,
        showProcessing: !0,
        showDelivery : !0
    },
    locale_site_map : {
        "fr_FR" : "fra", "pl_PL" : "pol", "ru_RU" : "rus", "pt_BR" : "bra",
        "es_ES" : "esp", "de_DE" : "deu", "it_IT" : "ita", "nl_NL" : "nld",
        "tr_TR" : "tur", "ja_JP" : "jpn", "ko_KR" : "kor", "th_TH" : "tha",
        "vi_VN" : "vnm", "ar_MA" : "ara", "iw_IL" : "isr", "pl_PL" : "pol"
    },
    shippingOptions: [
        {
            v: "CPAM",
            t: "China Post Registered Air Mail"
        }, {
            v: "EMS",
            t: "EMS"
        }, {
            v: "EMS_ZX_ZX_US",
            t: "ePacket"
        }, {
            v: "DHL",
            t: "DHL"
        }, {
            v: "FEDEX",
            t: "FedEx"
        }, {
            v: "SGP",
            t: "Singapore Post"
        }, {
            v: "TNT",
            t: "TNT"
        }, {
            v: "UPS",
            t: "UPS"
        }, {
            v: "USPS",
            t: "USPS"
        }
    ],
    shippingCurrencies: ["EUR", "GBP", "USD"],
    shippingCountries: [
        {
            v: "AF",
            t: "Afghanistan"
        }, {
            v: "ALA",
            t: "Aland Islands"
        }, {
            v: "AL",
            t: "Albania"
        }, {
            v: "GBA",
            t: "Alderney"
        }, {
            v: "DZ",
            t: "Algeria"
        }, {
            v: "AS",
            t: "American Samoa"
        }, {
            v: "AD",
            t: "Andorra"
        }, {
            v: "AO",
            t: "Angola"
        }, {
            v: "AI",
            t: "Anguilla"
        }, {
            v: "AQ",
            t: "Antarctica"
        }, {
            v: "AG",
            t: "Antigua and Barbuda"
        }, {
            v: "AR",
            t: "Argentina"
        }, {
            v: "AM",
            t: "Armenia"
        }, {
            v: "AW",
            t: "Aruba"
        }, {
            v: "ASC",
            t: "Ascension Island"
        }, {
            v: "AU",
            t: "Australia"
        }, {
            v: "AT",
            t: "Austria"
        }, {
            v: "AZ",
            t: "Azerbaijan"
        }, {
            v: "BH",
            t: "Bahrain"
        }, {
            v: "GGY",
            t: "Bailiwick of Guernsey"
        }, {
            v: "BD",
            t: "Bangladesh"
        }, {
            v: "BB",
            t: "Barbados"
        }, {
            v: "BY",
            t: "Belarus"
        }, {
            v: "BE",
            t: "Belgium"
        }, {
            v: "BZ",
            t: "Belize"
        }, {
            v: "BJ",
            t: "Benin"
        }, {
            v: "BM",
            t: "Bermuda"
        }, {
            v: "BT",
            t: "Bhutan"
        }, {
            v: "BO",
            t: "Bolivia"
        }, {
            v: "BA",
            t: "Bosnia and Herzegovina"
        }, {
            v: "BW",
            t: "Botswana"
        }, {
            v: "BV",
            t: "Bouvet Island"
        }, {
            v: "BR",
            t: "Brazil"
        }, {
            v: "IO",
            t: "British Indian Ocean Territory"
        }, {
            v: "VG",
            t: "British Virgin Islands"
        }, {
            v: "BG",
            t: "Bulgaria"
        }, {
            v: "BF",
            t: "Burkina Faso"
        }, {
            v: "BI",
            t: "Burundi"
        }, {
            v: "KH",
            t: "Cambodia"
        }, {
            v: "CM",
            t: "Cameroon"
        }, {
            v: "CA",
            t: "Canada"
        }, {
            v: "IC",
            t: "Canary Islands"
        }, {
            v: "CV",
            t: "Cape Verde"
        }, {
            v: "BQ",
            t: "Caribbean Netherlands"
        }, {
            v: "KY",
            t: "Cayman Islands"
        }, {
            v: "CF",
            t: "Central African Republic"
        }, {
            v: "TD",
            t: "Chad"
        }, {
            v: "CL",
            t: "Chile"
        }, {
            v: "CN",
            t: "China"
        }, {
            v: "CX",
            t: "Christmas Island"
        }, {
            v: "CC",
            t: "Cocos (Keeling) Islands"
        }, {
            v: "CO",
            t: "Colombia"
        }, {
            v: "KM",
            t: "Comoros"
        }, {
            v: "CK",
            t: "Cook Islands"
        }, {
            v: "CR",
            t: "Costa Rica"
        }, {
            v: "CI",
            t: "Cote D'Ivoire"
        }, {
            v: "HR",
            t: "Croatia"
        }, {
            v: "CU",
            t: "Cuba"
        }, {
            v: "CW",
            t: "Curacao"
        }, {
            v: "CY",
            t: "Cyprus"
        }, {
            v: "CZ",
            t: "Czech Republic"
        }, {
            v: "DK",
            t: "Denmark"
        }, {
            v: "DJ",
            t: "Djibouti"
        }, {
            v: "DM",
            t: "Dominica"
        }, {
            v: "DO",
            t: "Dominican Republic"
        }, {
            v: "EC",
            t: "Ecuador"
        }, {
            v: "EG",
            t: "Egypt"
        }, {
            v: "SV",
            t: "El Salvador"
        }, {
            v: "GQ",
            t: "Equatorial Guinea"
        }, {
            v: "ER",
            t: "Eritrea"
        }, {
            v: "EE",
            t: "Estonia"
        }, {
            v: "ET",
            t: "Ethiopia"
        }, {
            v: "FK",
            t: "Falkland Islands (Islas Malvinas)"
        }, {
            v: "FO",
            t: "Faroe Islands"
        }, {
            v: "FJ",
            t: "Fiji"
        }, {
            v: "FI",
            t: "Finland"
        }, {
            v: "FR",
            t: "France"
        }, {
            v: "PF",
            t: "French Polynesia"
        }, {
            v: "TF",
            t: "French Southern Territories"
        }, {
            v: "GA",
            t: "Gabon"
        }, {
            v: "GM",
            t: "Gambia"
        }, {
            v: "GE",
            t: "Georgia"
        }, {
            v: "DE",
            t: "Germany"
        }, {
            v: "GH",
            t: "Ghana"
        }, {
            v: "GI",
            t: "Gibraltar"
        }, {
            v: "GR",
            t: "Greece"
        }, {
            v: "GL",
            t: "Greenland"
        }, {
            v: "GD",
            t: "Grenada"
        }, {
            v: "GP",
            t: "Guadeloupe"
        }, {
            v: "GU",
            t: "Guam"
        }, {
            v: "GT",
            t: "Guatemala"
        }, {
            v: "GN",
            t: "Guinea"
        }, {
            v: "GW",
            t: "Guinea-Bissau"
        }, {
            v: "GY",
            t: "Guyana"
        }, {
            v: "GF",
            t: "Guyane French"
        }, {
            v: "HT",
            t: "Haiti"
        }, {
            v: "HN",
            t: "Honduras"
        }, {
            v: "HK",
            t: "Hong Kong"
        }, {
            v: "HU",
            t: "Hungary"
        }, {
            v: "IS",
            t: "Iceland"
        }, {
            v: "IN",
            t: "India"
        }, {
            v: "ID",
            t: "Indonesia"
        }, {
            v: "IQ",
            t: "Iraq"
        }, {
            v: "IE",
            t: "Ireland"
        }, {
            v: "IR",
            t: "Islamic Republic of Iran"
        }, {
            v: "IM",
            t: "Isle of Man"
        }, {
            v: "IL",
            t: "Israel"
        }, {
            v: "IT",
            t: "Italy"
        }, {
            v: "JM",
            t: "Jamaica"
        }, {
            v: "JP",
            t: "Japan"
        }, {
            v: "JEY",
            t: "Jersey"
        }, {
            v: "JO",
            t: "Jordan"
        }, {
            v: "KZ",
            t: "Kazakhstan"
        }, {
            v: "KE",
            t: "Kenya"
        }, {
            v: "KI",
            t: "Kiribati"
        }, {
            v: "KR",
            t: "Korea"
        }, {
            v: "KS",
            t: "Kosovo"
        }, {
            v: "KW",
            t: "Kuwait"
        }, {
            v: "KG",
            t: "Kyrgyzstan"
        }, {
            v: "LA",
            t: "Lao People's Democratic Republic"
        }, {
            v: "LV",
            t: "Latvia"
        }, {
            v: "LB",
            t: "Lebanon"
        }, {
            v: "LS",
            t: "Lesotho"
        }, {
            v: "LR",
            t: "Liberia"
        }, {
            v: "LY",
            t: "Libya"
        }, {
            v: "LI",
            t: "Liechtenstein"
        }, {
            v: "LT",
            t: "Lithuania"
        }, {
            v: "LU",
            t: "Luxembourg"
        }, {
            v: "MO",
            t: "Macau"
        }, {
            v: "MK",
            t: "Macedonia"
        }, {
            v: "MG",
            t: "Madagascar"
        }, {
            v: "MW",
            t: "Malawi"
        }, {
            v: "MY",
            t: "Malaysia"
        }, {
            v: "MV",
            t: "Maldives"
        }, {
            v: "ML",
            t: "Mali"
        }, {
            v: "MT",
            t: "Malta"
        }, {
            v: "MQ",
            t: "Martinique"
        }, {
            v: "MR",
            t: "Mauritania"
        }, {
            v: "MU",
            t: "Mauritius"
        }, {
            v: "YT",
            t: "Mayotte"
        }, {
            v: "MX",
            t: "Mexico"
        }, {
            v: "FM",
            t: "Micronesia"
        }, {
            v: "MC",
            t: "Monaco"
        }, {
            v: "MN",
            t: "Mongolia"
        }, {
            v: "MNE",
            t: "Montenegro"
        }, {
            v: "MS",
            t: "Montserrat"
        }, {
            v: "MA",
            t: "Morocco"
        }, {
            v: "MZ",
            t: "Mozambique"
        }, {
            v: "MM",
            t: "Myanmar"
        }, {
            v: "NA",
            t: "Namibia"
        }, {
            v: "NR",
            t: "Nauru"
        }, {
            v: "BN",
            t: "Negara Brunei Darussalam"
        }, {
            v: "NP",
            t: "Nepal"
        }, {
            v: "NL",
            t: "Netherlands"
        }, {
            v: "AN",
            t: "Netherlands Antilles"
        }, {
            v: "NC",
            t: "New Caledonia"
        }, {
            v: "NZ",
            t: "New Zealand"
        }, {
            v: "NI",
            t: "Nicaragua"
        }, {
            v: "NE",
            t: "Niger"
        }, {
            v: "NG",
            t: "Nigeria"
        }, {
            v: "NU",
            t: "Niue"
        }, {
            v: "NF",
            t: "Norfolk Island"
        }, {
            v: "KP",
            t: "North Korea"
        }, {
            v: "MP",
            t: "Northern Mariana Islands"
        }, {
            v: "NO",
            t: "Norway"
        }, {
            v: "OM",
            t: "Oman"
        }, {
            v: "PK",
            t: "Pakistan"
        }, {
            v: "PW",
            t: "Palau"
        }, {
            v: "PS",
            t: "Palestine"
        }, {
            v: "PA",
            t: "Panama"
        }, {
            v: "PG",
            t: "Papua New Guinea"
        }, {
            v: "PY",
            t: "Paraguay"
        }, {
            v: "PE",
            t: "Peru"
        }, {
            v: "PH",
            t: "Philippines"
        }, {
            v: "PN",
            t: "Pitcairn Islands"
        }, {
            v: "PL",
            t: "Poland"
        }, {
            v: "PT",
            t: "Portugal"
        }, {
            v: "PR",
            t: "Puerto Rico"
        }, {
            v: "QA",
            t: "Qatar"
        }, {
            v: "MD",
            t: "Republic of Moldova"
        }, {
            v: "RE",
            t: "Reunion"
        }, {
            v: "RO",
            t: "Romania"
        }, {
            v: "RU",
            t: "Russian Federation"
        }, {
            v: "RW",
            t: "Rwanda"
        }, {
            v: "BLM",
            t: "Saint Barthelemy"
        }, {
            v: "SH",
            t: "Saint Helena"
        }, {
            v: "KN",
            t: "Saint Kitts and Nevis"
        }, {
            v: "LC",
            t: "Saint Lucia"
        }, {
            v: "MF",
            t: "Saint Martin（France）"
        }, {
            v: "PM",
            t: "Saint Pierre and Miquelon"
        }, {
            v: "VC",
            t: "Saint Vincent and the Grenadines"
        }, {
            v: "WS",
            t: "Samoa"
        }, {
            v: "SM",
            t: "San Marino"
        }, {
            v: "ST",
            t: "Sao Tome and Principe"
        }, {
            v: "SA",
            t: "Saudi Arabia"
        }, {
            v: "SN",
            t: "Senegal"
        }, {
            v: "SRB",
            t: "Serbia"
        }, {
            v: "SC",
            t: "Seychelles"
        }, {
            v: "SL",
            t: "Sierra Leone"
        }, {
            v: "SG",
            t: "Singapore"
        }, {
            v: "SX",
            t: "Sint Maarten (Netherlands)"
        }, {
            v: "SK",
            t: "Slovakia"
        }, {
            v: "SI",
            t: "Slovenia"
        }, {
            v: "SB",
            t: "Solomon Islands"
        }, {
            v: "SO",
            t: "Somalia"
        }, {
            v: "ZA",
            t: "South Africa"
        }, {
            v: "SGS",
            t: "South Georgia and The South Sandwich Islands"
        }, {
            v: "SS",
            t: "South Sudan"
        }, {
            v: "ES",
            t: "Spain"
        }, {
            v: "LK",
            t: "Sri Lanka"
        }, {
            v: "SD",
            t: "Sudan"
        }, {
            v: "SR",
            t: "Suriname"
        }, {
            v: "SJ",
            t: "Svalbard and Jan Mayen"
        }, {
            v: "SZ",
            t: "Swaziland"
        }, {
            v: "SE",
            t: "Sweden"
        }, {
            v: "CH",
            t: "Switzerland"
        }, {
            v: "SY",
            t: "Syrian Arab Republic"
        }, {
            v: "TW",
            t: "Taiwan"
        }, {
            v: "TJ",
            t: "Tajikistan"
        }, {
            v: "HM",
            t: "Territory of Heard Island and McDonald Islands"
        }, {
            v: "TH",
            t: "Thailand"
        }, {
            v: "BS",
            t: "The Commonwealth of The Bahamas"
        }, {
            v: "ZR",
            t: "The Democratic Republic Of The Congo"
        }, {
            v: "CG",
            t: "The Republic of Congo"
        }, {
            v: "MH",
            t: "The Republic of Marshall Islands"
        }, {
            v: "VA",
            t: "The Vatican City State"
        }, {
            v: "TLS",
            t: "Timor-Leste"
        }, {
            v: "TG",
            t: "Togo"
        }, {
            v: "TK",
            t: "Tokelau"
        }, {
            v: "TO",
            t: "Tonga"
        }, {
            v: "TT",
            t: "Trinidad and Tobago"
        }, {
            v: "TN",
            t: "Tunisia"
        }, {
            v: "TR",
            t: "Turkey"
        }, {
            v: "TM",
            t: "Turkmenistan"
        }, {
            v: "TC",
            t: "Turks and Caicos Islands"
        }, {
            v: "TV",
            t: "Tuvalu"
        }, {
            v: "VI",
            t: "U.S.Virgin Islands"
        }, {
            v: "UG",
            t: "Uganda"
        }, {
            v: "UA",
            t: "Ukraine"
        }, {
            v: "AE",
            t: "United Arab Emirates"
        }, {
            v: "UK",
            t: "United Kingdom"
        }, {
            v: "TZ",
            t: "United Republic of Tanzania"
        }, {
            v: "US",
            t: "United States"
        }, {
            v: "UM",
            t: "United States Minor Outlying Islands"
        }, {
            v: "UY",
            t: "Uruguay"
        }, {
            v: "UZ",
            t: "Uzbekistan"
        }, {
            v: "VU",
            t: "Vanuatu"
        }, {
            v: "VE",
            t: "Venezuela"
        }, {
            v: "VN",
            t: "Vietnam"
        }, {
            v: "WF",
            t: "Wallis And Futuna"
        }, {
            v: "EH",
            t: "Western sahara"
        }, {
            v: "YE",
            t: "Yemen"
        }, {
            v: "ZM",
            t: "Zambia"
        }, {
            v: "EAZ",
            t: "Zanzibar"
        }, {
            v: "ZW",
            t: "Zimbabwe"
        }
    ],
    countryMapping: {
        GB: "UK",
        AX: "ALA",
        CG: "CG",
        CD: "CG",
        JE: "JEY",
        KV: "KS",
        ME: "MNE",
        RS: "SRB",
        GS: "SGS",
        BL: "BLM"
    },
    regionMapping: {
        US: {
            PR: {
                countryRegion: "PR",
                region: ""
            }
        }
    },
    phoneCountryCodes: {
        AD: "+376",
        AE: "+971",
        AF: "",
        AG: "+1 (268)",
        AI: "",
        AL: "+355",
        AM: "+374",
        AN: "",
        AO: "+244",
        AQ: "",
        AR: "+54",
        AS: "",
        ASC: "",
        AT: "+43",
        AU: "+61",
        AW: "+297",
        AX: "",
        AZ: "+994",
        BA: "+387",
        BB: "+1 (246)",
        BD: "+880",
        BE: "+32",
        BF: "+226",
        BG: "+359",
        BH: "+973",
        BI: "+257",
        BJ: "+229",
        BL: "",
        BM: "+1 (441)",
        BN: "+673",
        BO: "+591",
        BQ: "",
        BR: "+55",
        BS: "+1 (242)",
        BT: "+975",
        BV: "",
        BW: "+267",
        BY: "+375",
        BZ: "+501",
        CA: "+1",
        CC: "",
        CD: "+243",
        CF: "+236",
        CG: "+242",
        CH: "+41",
        CI: "+225",
        CK: "",
        CL: "+56",
        CM: "+237",
        CN: "+86",
        CO: "+57",
        CR: "+506",
        CU: "+53",
        CV: "+238",
        CW: "",
        CX: "",
        CY: "+357",
        CZ: "+420",
        DE: "+49",
        DJ: "+253",
        DK: "+45",
        DM: "+1 (767)",
        DO: "+1 (8)",
        DZ: "+213",
        EAZ: "",
        EC: "+593",
        EE: "+372",
        EG: "+20",
        EH: "+212",
        ER: "+291",
        ES: "+34",
        ET: "+251",
        FI: "+358",
        FJ: "+679",
        FK: "+500",
        FM: "+691",
        FO: "+298",
        FR: "+33",
        GA: "+241",
        GB: "+44",
        GBA: "",
        GD: "+1 (473)",
        GE: "+995",
        GF: "+594",
        GG: "+44",
        GGY: "+44",
        GH: "+233",
        GI: "+350",
        GL: "+299",
        GM: "+220",
        GN: "+224",
        GP: "+590",
        GQ: "+240",
        GR: "+30",
        GT: "+502",
        GU: "",
        GW: "+245",
        GY: "+592",
        HM: "",
        HN: "+504",
        HR: "+385",
        HT: "+509",
        HU: "+36",
        ID: "+62",
        IE: "+353",
        IL: "+972",
        IM: "+44",
        IN: "+91",
        IO: "",
        IQ: "+964",
        IR: "+98",
        IS: "+354",
        IT: "+39",
        JE: "+44",
        JEY: "+44",
        JM: "+1 (876)",
        JO: "+962",
        JP: "+81",
        KE: "+254",
        KG: "+996",
        KH: "",
        KI: "+686",
        KM: "+269",
        KN: "+1 (869)",
        KP: "+850",
        KR: "+82",
        KS: "",
        KW: "+965",
        KY: "+1 (345)",
        KZ: "+77",
        LA: "+856",
        LB: "+961",
        LC: "+1 (758)",
        LI: "+423",
        LK: "+94",
        LR: "+231",
        LS: "+266",
        LT: "+370",
        LU: "+352",
        LV: "+371",
        LY: "+218",
        MA: "+212",
        MC: "+377",
        MD: "+373",
        ME: "+382",
        MNE: "+382",
        MF: "",
        MG: "+261",
        MH: "+692",
        MK: "+389",
        ML: "+223",
        MM: "+95",
        MN: "+976",
        MP: "",
        MQ: "+596",
        MR: "+222",
        MS: "",
        MT: "+356",
        MU: "+230",
        MV: "+960",
        MW: "+265",
        MX: "+52",
        MY: "+60",
        MZ: "+258",
        NA: "+264",
        NC: "+687",
        NE: "+227",
        NF: "",
        NG: "+234",
        NI: "+505",
        NL: "+31",
        NO: "+47",
        NP: "+977",
        NR: "+674",
        NU: "",
        NZ: "+64",
        OM: "+968",
        PA: "+507",
        PE: "+51",
        PF: "+689",
        PG: "+675",
        PH: "+63",
        PK: "+92",
        PL: "+48",
        PM: "+508",
        PN: "",
        PR: "+1",
        PS: "",
        PT: "+351",
        PW: "+680",
        PY: "+595",
        QA: "+974",
        RE: "+262",
        RO: "+40",
        RS: "+381",
        SRB: "+381",
        RU: "+7",
        RW: "+250",
        SA: "+966",
        SB: "+677",
        SC: "+248",
        SD: "+249",
        SE: "+46",
        SG: "+65",
        SGS: "",
        SH: "",
        SI: "+386",
        SJ: "+47",
        SK: "+421",
        SL: "+232",
        SM: "+378",
        SN: "+221",
        SO: "+252",
        SR: "+597",
        SS: "+211",
        ST: "+239",
        SV: "+503",
        SX: "+590",
        SY: "+963",
        SZ: "+268",
        TC: "+1 (649)",
        TD: "+235",
        TF: "",
        TG: "+228",
        TH: "+66",
        TJ: "+992",
        TK: "",
        TL: "+670",
        TM: "+993",
        TN: "+216",
        TO: "+676",
        TR: "+90",
        TT: "+1 (868)",
        TV: "+688",
        TZ: "+255",
        UA: "+380",
        UG: "+256",
        UM: "",
        US: "+1",
        UY: "+598",
        UZ: "+998",
        VA: "+39 (066)",
        VC: "+1 (784)",
        VE: "+58",
        VG: "+1 (284)",
        VI: "",
        VN: "+84",
        VU: "+678",
        WF: "+681",
        WS: "+685",
        YE: "+967",
        YT: "+262",
        ZA: "+27",
        ZM: "+260",
        ZW: "+263",
        UK: "+44",
        HK: "+852"
    },
    api: {
        root_url: "http://plugins.ru/",
        product_list_url_part : "/wp-admin/admin.php?page=e2w_import",
        generateAuthCookie : "&e2w-json=auth/generate_auth_cookie",
        validateAuthCookie : "&e2w-json=auth/validate_auth_cookie",
        importList: "&e2w-json=get_products",
        productImport: "&e2w-json=add_product",
        productImportUpdate: "&e2w-json=upd_product",
        productDelete: "&e2w-json=del_product",
        getSettings: "&e2w-json=get_settings",
        orderSync: "&e2w-json=upd_order",
        checkProductsImported: "&e2w-json=get_products_info"
    },
};

function updateUrls(hostname) {
    var domain = hostname.match(/(ebay\.com|ebay.co.uk|ebay\.de|ebay.fr|ebay.it|ebay.es)/g);
    if (domain !== null) {

        for (var k in config.urls) {
            config.urls[k] = config.urls[k].replace('ebay.com', domain[0]);
        }
    }
}

updateUrls(window.location.hostname);

var mainPanel = {
    init : function(is_s){
        var i = document.querySelector("body");
        i && i.addEventListener("click", function (e) {
            if (e.target.id == 'ma-import-all' ){
                e.preventDefault();
                var p = [];

                if (!is_s){
                    var l = mainPanel.getEbayRunParams();

                    if (l !== false && l.items){
                        p = mainPanel.build_products_array2(l.items, p);

                    } else {
                        console.log('eBay2Woo Chrome extension can`t find items in the Run Params');
                    }
                } else {
                    l =  document.querySelector(".items-list");
                    if (l) p = mainPanel.build_products_array(l, p);
                }

                MAProduct.pushProductArr(p);
            }
        });

    },
    checkMassImportPossible : function(){
        if ($(".items-list").length || $('script:not([src]):contains("window.runParams")').length) return !0;
        else false;
    },
    getEbayRunParamsFromHTML(d){

        if (d.includes("window.runParams")) {
            const regex = /^.*window\.runParams\s*=\s*(.*?);\n/gs;

            var m, r = [];

            if ((m = regex.exec(d)) !== null && typeof m[1] !== "undefined") {

                r = m[1];

                r = r.replace('data:', '"data":');
                r = r.replace('csrfToken:', '"csrfToken":');
                r = r.replace('abVersion:', '"abVersion":');
                r = r.replace('abtestMap:', '"abtestMap":');
                r = r.replace(/:\s*?'(.*?)',/g, ':"$1",');
                json = JSON.parse(r);
                a = json && json.data?JSON.stringify(json.data):"";
                return a;
            }
        }

        return false;
    },
    getEbayRunParams : function(){
        var d = $('script:not([src]):contains("window.runParams")');
        if (d.length > 0) {
            const regex = /^.*window\.runParams = (.*);\n/gm;

            var m, r = [];

            while ((m = regex.exec(d.html())) !== null) {
                if (m.index === regex.lastIndex) {
                    regex.lastIndex++;
                }
                r.push(m);
            }

            if (r && r.length > 1) {
                return JSON.parse(r[1][1])
            } else {
                console.log('eBay2Woo Chrome extension detected that the Run params format is changed');
            }
        } else {
            console.log('eBay2Woo Chrome extension can`t can`t find Run params');
        }

        return false;

    },
    build_products_array : function(l, p, skip_child){
        var e = l;

        if (typeof skip_child == "undefined" || skip_child !== !0){
            e = l.children;
        }

        for (var t = 0; t < e.length; t += 1) {
            var r = e[t];
            d = mainPanel.getProductData(r);
            p.push( d );
        }
        return p;
    },
    build_products_array2 : function(l, p){

        for (var t = 0; t < l.length; t += 1) {
            var r = l[t];
            d = mainPanel.getProductData2(r);
            p.push( d );
        }
        return p;
    },
    getProductData2 : function(e){
        var eo = mainPanel;
        var data = {id : false, url : false, thumb : false, price_min : false, price_max : false, title : false, currency : false};

        var formatPrice = function(e){
            return e.replace(/[^0-9.,]\.*/g, '').replace(',','.');

        }

        data.id = e.productId;
        data.url = e.productDetailUrl;
        data.title =  e.title;
        data.thumb = e.imageUrl;

        var p = e.price.split('-');
        if (p){
            data.price_min = (typeof p[0] !== 'undefined') ? formatPrice(p[0]) : false;
            data.price_max = (typeof p[1] !== 'undefined') ? formatPrice(p[1]) : false;
        }

        data.currency = eo.getCurrency();

        return data;

    } ,
    getProductData : function(e){
        var eo = mainPanel;

        var data = {id : false, url : false, thumb : false, price_min : false, price_max : false, title : false, currency : false};

        var formatPrice = function(e){
            return e.replace(/[^0-9.,]\.*/g, '').replace(',','.');

        }

        r = $(e).find('h3 a');

        if (r.length) {
            data.url = r.attr('href');

            r = $(e).find('a[title]').attr('title');
            if (r){
                data.title =  r;
            }
        }
        else {
            r = $(e).find('a.item-title');
            if (r.length) {
                data.url = r.attr('href');
                data.title = r.attr('title');
            }
        }

        if (typeof data.url.match === "undefined"){

            return false;
        }

        var tmp = data.url.match(/.+\/([-a-zA-Zа-яА-Я0-9@%_\+~#=]{2,256})\/([0-9]+)/mi);
    //    var tmp = data.url.match(/.+\/([0-9,_]+)\.html/mi);

        if (tmp) {
            var p = tmp[1], s = p.split('_');
            if (s.length > 1){
                data.id = s[1];
            } else {
                data.id = s[0];
            }
        }

        r = $(e).find('.pic img');
        if (r.length && "" !== r[0].src) data.thumb = r[0].src;
        else {
            r = $(e).find('.product-img img');
            if (r.length && "" !== r[0].src) data.thumb = r[0].src;
        }

        r = $(e).find('.cost').length ? $(e).find('.cost') : $(e).find('.price-current');

        if (r.length && "" !== r[0].innerText){
            var p = r[0].innerText.split('-');
            if (p){
                data.price_min = (typeof p[0] !== 'undefined') ? formatPrice(p[0]) : false;
                data.price_max = (typeof p[1] !== 'undefined') ? formatPrice(p[1]) : false;
            }

            data.currency = eo.getCurrency();
        }

        return data;
    },
    getCurrency : function(e){

        return document.querySelector("span.currency").innerText
    },
    render : function() {
        if (mainPanel.checkMassImportPossible()) {
            if (window.location.href.indexOf("/store/") > -1) mainPanel.init(!0);
            else mainPanel.init();

            t = '<div id="ma-main-panel"><button id="ma-import-all">Import all products</button></div>';

            MAHtml.prependHtml(document, document.body, t);
        }
    }
}

var messagePanel = {
    iconClose : '', svgLogo : '', state : '', isBusy : false,
    init : function(t){
        messagePanel.isBusy = t.state.isBusy;
        messagePanel.iconClose = t.iconClose;
        messagePanel.svgLogo = t.svgLogo;
        messagePanel.state = t.state;

        messagePanel.remove();

        var i = document.querySelector("body");
        i && i.addEventListener("click", function (e) {
            if (e.target.parentElement.id == 'ma-close-popup' )
            e.preventDefault(), messagePanel.remove();
        })

    },
    remove : function(){
        var element = document.getElementById('ma-import-container');
        if (element){
            element.outerHTML = "";
            delete element;
        }
    },
    render : function (t){

        messagePanel.init(t);

        var get_btn_html = function(buttons){
             var html = '';
             var actions = messagePanel.state.actions;

             if (typeof actions == 'undefined') return html;

             for (var t = 0; t < actions.length;  t += 1){
                 var r = actions[t];
                 html += '<a ';
                 var tl = '';
                 for (var key in r) {
                    if (r.hasOwnProperty(key)) {

                        if (key === 'title') tl = r[key]
                        else if (key === 'action') attach_button_action(r)
                        else if (key !== 'arg' && key !== 'action') html += ' ' + key + '="' + r[key] + '"';

                    }
                 }

                 html += '">' + tl + '</a>';
             }

             return html == '' ? '' : '<p>'+html+'</p>';
        }

        var get_status_html = function(){
            var icon = messagePanel.state.iconUrl;
            return (typeof icon == 'undefined') ? '' : '<div class="img"><img src="' + chrome.extension.getURL(icon) +'"></div>';
        }

        var attach_button_action = function(action){
            var i = document.querySelector("body");
                i && i.addEventListener("click", function (e) {
                    if (e.target.id == action.id )
                    e.preventDefault(), action.action(action.arg);
                })
        }

       var t = '<div id="ma-import-container" class="ma-panel ma-panel-import"><div class="ma-panel-header">' +
         '<a href="#" id="ma-close-popup" class="close"><img src="' + messagePanel.iconClose + '"></a> <img src="' + messagePanel.svgLogo + '" alt="ma logo" class="ma-logo"></div>' +
         '<div id="ma-panel-import-content" class="ma-panel-import-content"><div>' + get_status_html() +
         '<h2><div>' + messagePanel.state.text + '</div></h2> <div></div>' + get_btn_html() + '</div></div></div>';

       MAHtml.appendHtml(document, document.body, t);
    }
}

var MA_Auth = {
    setLastAuthError : function(e){
        chrome.storage.sync.set({ ma_auth_error: e}, function(){});
    },
    getLastAuthError : function(f){
        chrome.storage.sync.get({
            ma_auth_error: false,
        }, function(data) {
            f(data.ma_auth_error);
        })
    },
    //background:
    ensureAuthCookie : function(f){
        chrome.storage.sync.get({
            ma_root_cookie: false,
        }, function(data) {
             if (data.ma_root_cookie === false){
                MA_Auth.generateAuthCookie(f);
            } else {
                MA_Auth.validateAuthCookie(data.ma_root_cookie, function(e) {
                    if (e.valid) f(e.cookie);
                    else {
                        MA_Auth.generateAuthCookie(f);
                    }
                });

                /* chrome.runtime.sendMessage({
                    action: config.actions.E_CONTENT_VALIDATE_AUTH_COOKIE,
                    cookie: data.ma_root_cookie
                }, function(e) {
                    if (e.valid) f(e.cookie);
                    else {
                        MA_Auth.generateAuthCookie(f);
                    }
                }); */
              }

          });
    },
    validateAuthCookie : function (cookie, f){
        var ext_options;

        var getValidateAuthCookiePromise = function(e){
            return (0, get_xhr_promise)({
                url: ext_options.root_url + config.api.validateAuthCookie,
                method: "POST",
                params: e,
                isForm: !0,
                isAjax: !0
            })
        }

        var validateAuthCookie = function(c, t) {
            var r = this,
                n = {cookie: c};
            getValidateAuthCookiePromise(n).then(function(d){
                var p = {cookie: n.cookie, status: d.statusText, valid: d.data.valid};
                t(p)
            }).catch(function(e) {
                if ( e.resultType === "timeout" ){
                        console.log("eBay2Woo Chrome extension detected the timeout of the generation Auth Cookie");
                        setTimeout(function(){
                            validateAuthCookie(n.cookie, t);
                        }, 600);
                } else {
                    console.log("eBay2Woo Chrome extension can`t generate Auth Cookie"), console.log(e), t(e)
                }
            })
        }

        config.get_ext_options(function(v){
            ext_options = v;
            validateAuthCookie(cookie, f);
        });
    },
    generateAuthCookie : function(f){
       /*   messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MA_Auth.getGenerateAuthCookieStateData()
          }); */

        /*  chrome.runtime.sendMessage({
                action: config.actions.E_CONTENT_GENERATE_AUTH_COOKIE
          }, function(e) { */

        var ext_options;

        var getAuthCookiePromise = function(/*e*/){

            return (0, get_xhr_promise)({
                url: ext_options.api_key + config.api.generateAuthCookie,
                method: "POST",
              /*  params: e,*/
                isForm: !0,
                isAjax: !0
            })
        }

        var getAuthCookie = function(t) {
            var r = this/*,
                        n = {username: ext_options.username,
                             password: ext_options.password}*/;



            if (ext_options.api_key == false) {
                MA_Auth.setLastAuthError('Can`t find Active store');
                t(false);
            }

            getAuthCookiePromise(/*n*/).then(function(d){
                var e = d.data;

                chrome.storage.sync.set({ ma_root_cookie: e.cookie}, function(){});

                if (e.status === 'ok' && e.cookie) t(e.cookie);
                else {
                    if ( typeof e.error !== 'undefined' && e.error)
                        MA_Auth.setLastAuthError(e.error);
                    t(false);
                }

            }).catch(function(e) {
                console.log("Generate Auth Cookie"), console.log(e), t(false)
            })
        }


        config.get_ext_options(function(v){
            ext_options = v;
            getAuthCookie(f);
        });

        // chrome.storage.sync.set({ ma_root_cookie: e.cookie}, function(){})
         /*
         messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MA_Auth.getGeneratedAuthCookieStateData(e)
         });  */

        /*if (e.status === 'ok' && e.cookie) f(e.cookie);
        else f(false);*/

         /* })*/
    },

    //all:
    resetAuthCookie : function (f){
        chrome.storage.sync.set({ ma_root_cookie: false}, f)
    },

    //content:
    testConnection : function (f){
        messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MA_Auth.getTestConnectionStateData()
        });

        chrome.runtime.sendMessage(
            { action: config.actions.E_CONTENT_TEST_CONNECTION},
            function(e) {

                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MA_Auth.getTestedConnectionStateData(e)
                });

                f(e);
            }
        );
    },

    getTestConnectionStateData : function(){
       var t = {
            text: "Attempting to authenticate...",
            isBusy: true,
        };
        return t
    },

    getTestedConnectionStateData : function(e){

         var t = {};
         if (e.status === 'ok'){
            t = {
                text: 'Authentication is successful!',
                isBusy: false,
                iconUrl: config.assets.iconImportSuccess,
                actions: []
            };
         } else {
             t = {
                text: 'Authentication failed. ' + e.error,
                isBusy: false,
                iconUrl: config.assets.iconImportError,
                actions: [{
                    id: "ma-to-settings",
                    href: "/options.html",
                    target: "_blank",
                    className: '',
                    title: "Configure settings",
                    arg: '',
                    action: MA_Auth.openSettingTab
                }]
            };
         }

         return t;
    },
    getCustomStateData : function (e){
         var t = {};

        return e.success ? (t = {
            text:  e.msg,
            iconUrl: config.assets.iconImportSuccess,
        }) : (t = {
            text: e.msg,
            iconUrl: config.assets.iconImportError,
        }), t
    },
    openSettingTab : function(){
         chrome.runtime.sendMessage({action: config.actions.E_CONTENT_OPEN_SETTING_TAB }, function(e) {});
    }
}

var MAProduct = {
    requestProductInfo : function(t, r, f) {

        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_GET_PRODUCT_INFO,
            params: t,
            reqId: r
        }, function(e) {

            if(typeof f !== "undefined") f(e);

        });
    },
    pushProduct: function(e, i, th, pmn, pmx, ttl, cur, apd, f) {

       return new Promise(function(resolve, reject){

             messagePanel.render({
                iconClose : chrome.extension.getURL(config.assets.iconClose),
                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                state: MAProduct.getPushStateData({id : i}),
             });

             chrome.runtime.sendMessage({
                action: config.actions.E_CONTENT_PUSH_PRODUCT_TO_APP,
                url: e,
                id: i,
                thumb: th,
                price_min: pmn,
                price_max: pmx,
                title: ttl,
                currency: cur,
                 apd: apd,
             }, function(e) {
                if (e.status == 'OK') e.success = true;
                else e.success = false;

                config.get_ext_options(function(v){

                    ext_options = v;

                    messagePanel.render({
                        iconClose : chrome.extension.getURL(config.assets.iconClose),
                        svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                        state: MAProduct.getPushedStateData({id : e.id, url : e.url, th : e.th, pmn : e.pmn, pmx : e.pmx, ttl : e.ttl, cur : e.cur, success : e.success, api_root_url : ext_options.api_root_url,
                        msg : ((typeof e.status_text !== 'undefined') ? e.status_text : '')})
                    });
                });

                if(typeof f !== "undefined") f();


                if (e.status == 'OK') resolve({data: e});
                else reject(new Error( (typeof e.status_text !== 'undefined') ? e.status_text : '' ));

             })

       });

    },
    pushProductSilent : function(e, i, th, pmn, pmx, ttl, cur, apd){
        return new Promise(function(resolve, reject){
           //  setTimeout( function(){
            chrome.runtime.sendMessage({
                action: config.actions.E_CONTENT_PUSH_PRODUCT_TO_APP,

                url: e,
                id: i,
                thumb: th,
                price_min: pmn,
                price_max: pmx,
                title: ttl,
                currency: cur,
                apd: apd,
            }, function(e) {
                if (e.status == 'OK') e.success = true;
                else if (e.status == 'warning' && e.warning == "Product already exist"){
                    e.success = true;
                }
                else e.success = false;

                 if (e.status == 'OK') resolve({data: e});
                 else reject(new Error( (typeof e.status_text !== 'undefined') ? e.status_text : '' ));

            });
           // }, interval);
        });
    },
    pushProductArr : function(p){

        var pushProductSilentWithInfo = function(e, i, th, pmn, pmx, ttl, curr){

            return new Promise(function(r) {
                var params = {'id': i};
                var reqId = Math.random().toString();
                var data = {params, "reqId": reqId};

                MAProduct.requestProductInfo(data.params, data.reqId, function (d) {

                    r(d);

                });
            }).then(function(e){
                return MAProduct.pushProductSilent(e, i, th, pmn, pmx, ttl, curr, e.data);
            });

        }

        var firstPush = '', failed_p = [];

        if (p.length > 0 ) firstPush = function(el){

            messagePanel.render({
                iconClose : chrome.extension.getURL(config.assets.iconClose),
                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                state: MAProduct.getMassPushStateData({success : true, number : p.length}),
            });

            return  pushProductSilentWithInfo(el.url, el.id, el.thumb, el.price_min, el.price_max, el.title, el.currency);
        }

        (p[0]).then(function(){
            if (p.length > 1) {

                var do_push  = function(p, t){
                    firstPush = firstPush.then(function(val){

                        el = p[t];

                        if (t+1 < p.length) {

                            messagePanel.render({
                                iconClose : chrome.extension.getURL(config.assets.iconClose),
                                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                                state: MAProduct.getMassPushStateData({success : true, number : p.length - t}),
                             });

                            do_push(p, t+1);
                        } else if ( t+1 === p.length) {

                            var params = {success : !0};
                            if (failed_p.length > 0){
                                params.success = false;
                                params.error = failed_p.length + ' product(s) - not imported. Try to import them again?';
                                params.arr = failed_p;
                            }

                            messagePanel.render({
                                iconClose : chrome.extension.getURL(config.assets.iconClose),
                                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                                state: MAProduct.getMassPushedStateData(params),
                            });
                        }

                        return pushProductSilentWithInfo(el.url, el.id, el.thumb, el.price_min, el.price_max, el.title, el.currency);

                      //  }
                    }).catch(function(err){

                        failed_p.push(el);

                        if (err.message === "Can`t find Active store"){
                            messagePanel.render({
                                iconClose : chrome.extension.getURL(config.assets.iconClose),
                                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                                state: MA_Auth.getTestedConnectionStateData({status : 'no', error: err.message}),
                            })
                        }
                        else {
                            console.log(err.message);
                        }
                    });
                }

                do_push(p, 1);

            } else {
                //for 1-length array

                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MAProduct.getMassPushedStateData({success : !0}),
                });
            }
        }).catch(function(err){
            failed_p.push(p[0]);

            if (err.message === "Can`t find Active store"){

                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MA_Auth.getTestedConnectionStateData({status : 'no', error: err.message}),
                });
            } else if (err.message == "Product already imported." && p.length > 1){

                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MAProduct.getMassPushedWarningStateData({error: err.message + " Skip it..."}),
                });

                p.shift()

                setTimeout(function(){
                    MAProduct.pushProductArr(p);
                }, 700);

            }
            else {
                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MAProduct.getMassPushedStateData({success : false, error: err.message, arr : p, ind : 0}),
                });
            }
        });

    },
    sendProductHtml : function(e,i){

        messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MAProduct.getPushHtmlStateData({id : i}),
        });

        chrome.runtime.sendMessage({
            action: config.actions.E_GET_AND_PUSH_PRODUCT_HTML_TO_APP,
            url: e,
            id: i
        }, function(e) {
            if (e.status == 'OK') e.success = true;
            else e.success = false;

            config.get_ext_options(function(v){

                ext_options = v;

                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MAProduct.getPushedHtmlStateData({id : e.id, success : e.success, api_root_url : ext_options.root_url,
                    msg : ((typeof e.status_text !== 'undefined') ? e.status_text : '')})
                });
            });
        })

    },
    syncProductList : function(){

        messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MAProduct.getSyncStateData()
        });


        chrome.runtime.sendMessage({
            action: config.actions.E_SYNC_PRODUCT_LIST
        }, function(e) {
            if (e.status == 'OK') e.success = true;
            else e.success = false;

            messagePanel.render({
                iconClose : chrome.extension.getURL(config.assets.iconClose),
                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                state: MAProduct.getSyncedStateData({success : e.success, msg : ((typeof e.status_text !== 'undefined') ? e.status_text : '')}),
            });

        });
    },
    removeProduct : function(e) {

        messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MAProduct.getRemoveStateData({id : e.id})
        });

        chrome.runtime.sendMessage({
            action: config.actions.E_CONTENT_DELETE_PRODUCT_FROM_APP,
            id: e.id
        }, function(e) {

            if (e.status == 'OK') e.success = true;
            else
                e.success = false;

            messagePanel.render({
                iconClose : chrome.extension.getURL(config.assets.iconClose),
                svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                state: MAProduct.getRemovedStateData({id : e.id, success : e.success,
                msg : ((typeof e.status_text !== 'undefined') ? e.status_text : '') })
            });
        })
    },

    getSyncStateData : function (){
       var e = {
            text: "Sync product data...",
            isBusy: true,
       };
       return e
    },
    getSyncedStateData : function (e){
         var t = {};

        return e.success ? (t = {
            text: "Product data was synced Successfully." + "<br/><br/>" + e.msg,
            iconUrl: config.assets.iconImportSuccess,
        }) : (t = {
            text: "Synchronization Failed." + "<br/><br/>" + e.msg,
            iconUrl: config.assets.iconImportError,
        }), t
    },
    getPushStateData : function(e) {
        var e = {
            text: "Product (id: " + e.id + ") being Imported...",
            isBusy: true,
        };
        return e
    },
    getMassPushStateData : function(e) {
        var e = {
            text: "Mass import product: " + e.number + " remaining, please wait...",
            isBusy: true,
        };
        return e
    },
    getMassPushedWarningStateData : function(e) {
        var t = {
            text: "The mass import product warning!\n" + e.error,
            isBusy: false,
            iconUrl: config.assets.iconImportError,
            actions: []
        };

        return t;
    },
    getMassPushedStateData : function(e) {
        var t = {
            text: e.success ? "Mass import product: completed!" : "The mass import product: failed!\n" + e.error,
            isBusy: false,
            iconUrl: e.success ? config.assets.iconImportSuccess : config.assets.iconImportError,
            actions: []
        };

        return e.success ? void 0 : (t.actions = [{
            id: "ma-restart-button",
            href: "#",
            target: "_blank",
            className: '',
            title: "Yes, import",
            arg: e,
            action: function(i){
                MAProduct.pushProductArr(i.arr);
            }
        },{
            id: "ma-close-button",
            href: "#",
            target: "_blank",
            className: '',
            title: "No, close",
            arg: e,
            action : function(e){ messagePanel.remove()}
        }]), t
    },
    getPushedStateData : function(e) {
        var t = {
            text: e.success ? "Product (id: " + e.id + ") Imported Successfully." + "<br/><br/>" + e.msg : "Product (id: " + e.id + ") Import Failed." + "<br/><br/>" + e.msg,
            isBusy: false,
            iconUrl: e.success ? config.assets.iconImportSuccess : config.assets.iconImportError,
            actions: []
        };
        return e.success ? (t.actions = [{
                href:  e.api_root_url + config.api.product_list_url_part,
                target: "_blank",
                title: "Open Import List"
            }, {
                id: "ma-remove-product",
                href: "#",
                target: '',
                className: "ma-text-danger",
                title: "Remove",
                arg: e.id,
                action: function(i) { MAProduct.removeProduct({id: i}) }
            }]) : (t.actions = [{
                    id: "ma-retry-button",
                    href: "#",
                    target: "_blank",
                    className: '',
                    title: "Try again",
                    arg: e,
                    action: function(i){ MAProduct.pushProduct(i.url, i.id, i.th, i.pmn, i.pmx, i.ttl, i.cur)}
                },{
                    id: "ma-to-settings",
                    href: "#settings",
                    target: "_blank",
                    className: '',
                    title: "Configure settings",
                    arg: '',
                    action: MA_Auth.openSettingTab
                }]), t
    },
    getCheckImportedStateData : function(e){

        var t = {
            text: e.status_text,
            isBusy: false,
            iconUrl: config.assets.iconImportError,
            actions: []
        };

        if (e.status_text == "Can`t find Active store" || e.status_text == "Can't connect to your store using this key."){
            t.actions = [{
                id: "ma-to-settings",
                href: "#settings",
                target: "_blank",
                className: '',
                title: "Configure settings",
                arg: '',
                action: MA_Auth.openSettingTab
            }]
        }

        return  t;
    },
    getPushHtmlStateData : function (e){
        var e = {
            text: "Product html (id: " + e.id + ") being Imported...",
            isBusy: true,
        };
        return e
    },
    getPushedHtmlStateData : function(e) {
        var t = {
            text: e.success ? "Product html (id: " + e.id + ") Imported Successfully." + "<br/><br/>" + e.msg : "Product html (id: " + e.id + ") Import Failed." + "<br/><br/>" + e.msg,
            isBusy: false,
            iconUrl: e.success ? config.assets.iconImportSuccess : config.assets.iconImportError,
            actions: []
        };
        return e.success ? (t.actions = [{
            id: "ma-close-button",
            href: "#",
            target: "_blank",
            className: '',
            title: "OK",
            arg: e,
            action : function(e){ messagePanel.remove()}
        }]) : (t.actions = [{
                id: "ma-retry-button",
                href: "#",
                target: "_blank",
                className: '',
                title: "Try again",
                arg: e,
                action: function(i){ MAProduct.sendProductHtml(i.url, i.id)}
            }]), t
    },
    getRemoveStateData : function(e) {
        var e = {
            text: "Deleting product (id: " + e.id + ")...",
            isBusy: true,
        };
        return e
    },
    getRemovedStateData : function(e) {
        var t = {};

        return e.success ? (t = {
            text: "Product (id: " + e.id + ") deleted Successfully." + "<br/><br/>" + e.msg,
            iconUrl: config.assets.iconImportSuccess,
        }) : (t = {
            text: "Product (id: " + e.id + ") deleted Failed." + "<br/><br/>" + e.msg,
            iconUrl: config.assets.iconImportError,
        }), t

    },
    getAttrValueIndexes(html="", attrArray = []){
        var found = html.match(/window\.runParams = {([.\s\S]*?)};/i);
        var fullObjectStr = found && found[1]?found[1].trim():"";
        found = fullObjectStr.match(/data: {([.\s\S]*)},[.\s\S]*csrfToken/i);
        var object = found && found[1]?JSON.parse("{"+found[1]+"}"):{};
        if(object.skuModule && object.skuModule.productSKUPropertyList){
        return attrArray.reduce((acc,aId)=>{
        const values = object.skuModule.productSKUPropertyList.reduce((acc,val,attrIndex)=>{
        let valIndex = val.skuPropertyValues.findIndex(v=>v.propertyValueId.toString()===aId.toString())
        return valIndex!==-1?[...acc,{attrIndex,valIndex}]:acc
        },[])
        return [...acc,...values];
        },[])
        }
        return []
    }
}

var MAOrder = {
    updateOrder : function(e, f) {

        messagePanel.render({
            iconClose : chrome.extension.getURL(config.assets.iconClose),
            svgLogo : chrome.extension.getURL(config.assets.svgLogo),
            state: MAOrder.getUpdateStateData({id : e.id})
        });

         chrome.runtime.sendMessage({
             action: config.actions.E_CONTENT_ORDER_FULFILLMENT_RESPONSE, id: e.id }, function(e) {

                if (e.status == 'OK')
                    e.success = true;
                else
                    e.success = false;

                messagePanel.render({
                    iconClose : chrome.extension.getURL(config.assets.iconClose),
                    svgLogo : chrome.extension.getURL(config.assets.svgLogo),
                    state: MAOrder.getUpdatedStateData({id : e.id, external_id : e.external_id, success : e.success,
                        msg : ((typeof e.status_text !== 'undefined') ? e.status_text : '') })
                });

                if (typeof f !== "undefined") f(e);

            })
    },

    sendStatus : function(e,f,d){
        chrome.runtime.sendMessage({
            action: config.actions.E_CONTENT_ORDER_FULFILLMENT_STATUS_RESPONSE, stage: e.stage, param: typeof d !== "undefined" ? d : !1 }, function(e) {
            if (typeof f !== "undefined") f(e);
        })
    },

    getUpdateStateData : function(e) {
        var e = {
            text: "Sync Order (id: " + e.id.join('<br />') + ") with WooCommerce...",
            isBusy: true,
        };
        return e
    },
    getUpdatedStateData : function(e) {
        var t = {};

        return e.success ? (t = {
            text: "Order (id: " + e.external_id.join('<br />') + ") - saved in your WC Order." + "<br/><br/>" + e.msg,
            iconUrl: config.assets.iconImportSuccess,
        }) : (t = {
            text: "Order (id: " + e.external_id.join('<br />') + ") Syncing Failed. Please copy it manually to your WC order." + "<br/><br/>" + e.msg,
            iconUrl: config.assets.iconImportError,
        }), t

    },
    clear : function(f){
        chrome.storage.sync.set({
            orderId: !1,
            orderItems: !1,
            orderNumber: !1,
            shopName: !1,
            currentProduct: 0,
            orderData: !1,
            defaultShipping: "",
            note: !1,
            cartLoaded: !1,
            formFilled: 0,
            countrySet: 0,
            createdAt: !1,
        },function() {
            if (typeof f !== "undefined") f();
        });
    }
}

//MAOrder.clear();

var MAFunc = {

    serialize : function(obj, prefix) {
        var str = [],
            p;
        for (p in obj) {
            if (obj.hasOwnProperty(p)) {
                var k = prefix ? prefix + "[" + p + "]" : p,
                    v = obj[p];
                str.push((v !== null && typeof v === "object") ?
                    serialize(v, k) :
                    encodeURIComponent(k) + "=" + encodeURIComponent(v));
            }
        }
        return str.join("&");
    },

    goToPluginTab : function(f){

        chrome.runtime.sendMessage({
            action: config.actions.E_CONTENT_SWITCH_TO_PLUGIN_TAB_REQUEST}, function(e) {
            if (typeof f !== "undefined") f(e);
        })
    },


    parseAvailableProductShopcartIds : function() {
        var e = !0,
            t = !1,
            r = void 0;
        try {
            for (var n, o = document.head.querySelectorAll("script")[Symbol.iterator](); !(e = (n = o.next())
                .done); e = !0) {
                var i = n.value,
                    a = i.innerText.match(/availableProductShopcartIds":\s"([\d,]+)",/);
                if (null !== a) return a[1]
            }
        } catch (e) {
            t = !0, r = e
        } finally {
            try {
                !e && o.return && o.return()
            } finally {
                if (t) throw r
            }
        }
        return null
    },

    testRequest : function(){
        chrome.runtime.sendMessage({
            action: config.actions.E_CONTENT_TEST_REQUEST
        }, function (e) {

        })
    },

    getSetEbayAddressStateData : function(e){
        var t = {}, s = "Some errors occured: <br/>";

        for (var h in e.messages) {
            s = s + e.messages[h] + "<br/>";
        }

        return e.success ? (t = {
            text:  e.status,
            iconUrl: config.assets.iconImportSuccess,
        }) : (t = {
            text: s,
            iconUrl: config.assets.iconImportError,
        }), t
    },

    setEbayAddress : function(d){

        return new Promise(function(n, l) {

            setTimeout(function(){

                var t = MAFunc.parseCsrfToken(),
                i = MAFunc.parseAvailableProductShopcartIds();

                if (t !== null && i !== null) {
                    chrome.runtime.sendMessage({
                        action: config.actions.E_CONTENT_SET_ADDRESS, token: t, ids : i, data: d
                    }, function (e) {

                        if (e.success !== !0 && e.messages && e.messages.length > 0) {
                            console.log('eBay2Woo Chrome extension can`t set the address for this order using the fast methods. Below the errors:');
                         /*   messagePanel.render({
                                iconClose: chrome.extension.getURL(config.assets.iconClose),
                                svgLogo: chrome.extension.getURL(config.assets.svgLogo),
                                state: MAFunc.getSetEbayAddressStateData(e)
                            });*/
                        }

                        return n(e);

                    });
                } else {
                    if (t == null) {
                        return l("eBay2Woo Chrome extension can`t can't get the eBay api token");
                    }
                    if (i == null){
                        return l("eBay2Woo Chrome extension can`t can't get cart product ids");
                    }
                }
            },1000);
        });
    },

    checkPageNotFound : function(u){
        return new Promise(function(n) {
            chrome.runtime.sendMessage({
                action: config.actions.E_CONTENT_TEST_PAGE_NOT_FOUND, url: u
            }, function (e) {
                return n(e);
            });
        });
    },

    parseCsrfToken : function() {
        var e = !0,
            t = !1,
            r = void 0;
        try {
            for (var n, o = document.body.querySelectorAll("script")[Symbol.iterator](); !(e = (n = o.next())
                .done); e = !0) {
                var i = n.value,
                    a = i.innerText.match(/\._csrf_token_\s=\s'(\w+)';/);
                if (null !== a) return a[1]
            }
        } catch (e) {
            t = !0, r = e
        } finally {
            try {
                !e && o.return && o.return()
            } finally {
                if (t) throw r
            }
        }
        return null
    },

    setPopup : function(p){
        chrome.runtime.sendMessage({
            action: config.actions.E_CONTENT_SET_POPUP, popup: p
        }, function (e) {

        });
    },

    isEbayPage : function(url){
        const matches = ["https://*.ebay.com/*","https://*.ebay.co.uk/*","https://*.ebay.de/*","https://*.ebay.fr/*","https://*.ebay.it/*","https://*.ebay.es/*"];
        return MAFunc.isPageMathing(url, matches);
    },

    isEbayCatPage : function(url){
        const matches = ["https://ebay.com/b/*","https://ebay.co.uk/b/*","https://ebay.de/b/*","https://ebay.fr/b/*","https://ebay.it/b/*","https://ebay.es/b/*"];
        return MAFunc.isPageMathing(url, matches);
    },

    isPageMathing : function (url, matches){
        function urlGlobToRegex(matchPattern) {
            return matchPattern
                .replace(/[.]/g, '\\.')
                .replace(/[?]/, '.')
                .replace(/^[*]:/, 'https?')
                .replace(/^(https[?]?:[/][/])[*]/, '$1[^/:]+')
                .replace(/^(http[?]?:[/][/])[*]/, '$1[^/:]+')
                .replace(/[/][*]/, '/?.+')
                .replace(/[*]/g, '.+')
                .replace(/[/]/g, '\\/');
        }

        const matchesRegex = new RegExp('^('+ matches.map(urlGlobToRegex).join('|') + ')$');

        return matchesRegex.test(url);
    },

    injectMainJs : async function(tabId){

        'use strict';

        async function wasPreviouslyLoaded (tabId, js) {

            async function p(fn, ...args) {
                return new Promise((resolve, reject) => {
                    fn(...args, result => {
                        if (chrome.runtime.lastError) {
                           //  reject(chrome.runtime.lastError);
                            resolve(false);
                        }
                         else {
                            result = result || {};
                            if (result.status != 'yes') {
                                resolve(false);
                            } else {
                                resolve(true);
                            }

                        }
                    });
                });
            }

            const result = await p(chrome.tabs.sendMessage, tabId, {
                "name": config.actions.E_CHECK_MAIN_CONTENT_IS_INCLUDED
            });

            return result;
        }

        async function isOriginPermitted(url) {
            return p(chrome.permissions.contains, {
                origins: [new URL(url).origin + '/*']
            });
        }

        function urlGlobToRegex(matchPattern) {
            return matchPattern
                .replace(/[.]/g, '\\.')
                .replace(/[?]/, '.')
                .replace(/^[*]:/, 'https?')
                .replace(/^(https[?]?:[/][/])[*]/, '$1[^/:]+')
                .replace(/^(http[?]?:[/][/])[*]/, '$1[^/:]+')
                .replace(/[/][*]/, '/?.+')
                .replace(/[*]/g, '.+')
                .replace(/[/]/g, '\\/');
        }

        async function p(fn, ...args) {
            return new Promise((resolve, reject) => {
                fn(...args, result => {
                    if (chrome.runtime.lastError) {
                        reject(chrome.runtime.lastError);
                    }
                    else {
                        resolve(result);
                    }
                 });
            });
        }

        const js = [
            {file: 'assets/js/libs/jquery.js'},
            {file: 'assets/js/scripts/common.js'},
            {file: 'scripts/content/content_ma_api.js'}
        ];

        const loadCheck = `document[${JSON.stringify(JSON.stringify({ js }))}]`;

        const matchAboutBlank = false;

        const allFrames = false;

        const runAt = "document_end";

        const matches = ["https://*.ebay.com/*","https://*.ebay.co.uk/*","https://*.ebay.de/*","https://*.ebay.fr/*","https://*.ebay.it/*","https://*.ebay.es/*"];

        const { url } = await p(chrome.tabs.get, tabId);

        const matchesRegex = new RegExp('^('+ matches.map(urlGlobToRegex).join('|') + ')$');

        if (!url ||
            matchesRegex.test(url) ||
            !await isOriginPermitted(url)
        ) {
            return false;
        }

        if ( await wasPreviouslyLoaded(tabId, loadCheck)){
            return true;
        }

        for (const file of js) {
            chrome.tabs.executeScript(tabId, {
                ...file,
                matchAboutBlank,
                allFrames,
                runAt
            });
        }

        chrome.tabs.executeScript(tabId, {
            code: `${loadCheck} = true`,
            runAt: 'document_start',
            allFrames
        });

        return true;
    },

    isScriptAlreadyIncluded : function(sub_src){
        var scripts = document.getElementsByTagName("script");
        for(var i = 0; i < scripts.length; i++){
            t = scripts[i].getAttribute('src');
            if(t && t.includes(sub_src)) return true;
        }
        return false;
    }

}

var MAHtml = {
    prependHtml : function(e, t, r){
        if (t && r) {
            var o = e.createElement("template");
            //o.innerHTML = r, n ? t.append(o.content.firstChild) : t.prepend(o.content.firstChild)
            o.innerHTML = r, t.prepend(o.content.firstChild)
        }
    },
    appendHtml : function(e, t, r){
        if (t && r) {
            var o = e.createElement("template");
            o.innerHTML = r;
            t.append(o.content.firstChild)
        }
    },
}

var MAMessages = {

    productImportedIcon : function() {
        var s = chrome.extension.getURL(config.assets.iconImported);
        return '<a href="#" class="ma-imported-product" title="This product is already added into your store"><img src="' + s + '" alt=""></a>'
    },

    categoryProductImportedIcon : function() {
        var s = chrome.extension.getURL(config.assets.iconImported);
        return '<a href="#" class="ma-imported-category-product" title="This product is already added into your store"><img src="' + s + '" alt=""></a>'
    },

    productPushButton : function() {
        var btnFloating = chrome.extension.getURL(config.assets.btnFloating);
        return '<a href="#" id="ma-push-button" class="ma-btn-push-product" title="Add this product to the Import List"><img src="' + btnFloating + '" alt=""></a>'
    },

    categoryPushButton : function(){
        var btnFloating = chrome.extension.getURL(config.assets.btnFloating);
        return '<a href="#" class="ma-btn-push-category-product" title="Add this product to the Import List"><img src="' + btnFloating + '" alt=""></a>'
    },

    statusBar : function() { return  '<div id="ma-status-bar-container"></div>' }
}

var MAStatusBar = {
    add : function(e) {
        var logoSM = chrome.extension.getURL(config.assets.logoSM);
        jQuery("#ma-status-bar-container").append('<div class="status-bar" style="background: url(' + logoSM + ') no-repeat 16px center #fff;">' + e + "</div>")
    },
    remove : function() {
        jQuery("#ma-status-bar-container").html("")
    }
}

var MAPromises = {
    clickBtn : function(e) {
        return new Promise(function(t, n) {
            var r = setInterval(function() {

                var n = e;
                if (typeof e !== "object")
                    n = document.querySelector(e);

                n && (clearInterval(r), n.click(), t(n));

            }, 400);

            setTimeout(function() {
                clearInterval(r), n(!1);
            }, 5000)
        })
    },

    waitEl : function(e,c) {
        return new Promise(function(t, n) {
            var r = setInterval(function() {
                var n = e;
                if (typeof e !== "object")
                    n = document.querySelector(e);

                if ( typeof c !== 'undefined' ){
                    if (c == ':visible'){
                        n && n.is(":visible") && (clearInterval(r), t(n));
                    } else {
                        n && n.classList.contains(c) && (clearInterval(r), t(n));
                    }

                } else {
                    n && (clearInterval(r), t(n));
                }

            }, 400);

            setTimeout(function() {
                clearInterval(r), n(!1);
            }, 20000)
        })
    }

}

