function e2w_get_order_fulfillment(data, callback){

    var storeEvent = new CustomEvent('E_order_fulfillment', {"detail":data});

    document.addEventListener('E_order_fulfillment_status_response', function respListener(event) {
        var data = event.detail;

        if (typeof callback !== "undefined")
            callback(data);

        if (data.stage == 5){
            document.removeEventListener('E_order_fulfillment_status_response', respListener);
        }

    });

    document.dispatchEvent(storeEvent);
}
/*
function e2w_get_order_tracking_code(data, callback){
     var storeEvent = new CustomEvent('order_tracking_code', {"detail":data});

    document.addEventListener('E_order_tracking_code_response', function respListener(event) {
        var data = event.detail;

        callback(data);

        document.removeEventListener('E_order_tracking_code_response', respListener);

    });

    document.dispatchEvent(storeEvent);
}
*/


function e2w_get_product(params, callback) {
    var reqId = Math.random().toString();
    var data = {params, "reqId":reqId};
    var storeEvent = new CustomEvent('E_WEB_GET_PRODUCT_INFO_REQUEST', {"detail":data});

    document.addEventListener('E_WEB_GET_PRODUCT_INFO_RESPONSE', function respListener(event) {
        var data = event.detail;
        if(data.reqId == reqId) {
            callback(data.status, data.data, data.error_msg);
            document.removeEventListener('E_WEB_GET_PRODUCT_INFO_RESPONSE', respListener);
        }
    });

    document.dispatchEvent(storeEvent);
}

function e2w_go_to_payall(){
    var e = new CustomEvent('E_order_fulfillment_payall');
    document.dispatchEvent(e);
}

function e2w_close_chrome_tab(){
    var e = new CustomEvent('E_close_chrome_tab');
    document.dispatchEvent(e);
}

function e2w_switch_to_chrome_tab(){
    var e = new CustomEvent('E_switch_to_chrome_tab');
    document.dispatchEvent(e);
}

var maAPILoaded = new CustomEvent('maAPILoaded');
document.dispatchEvent(maAPILoaded);

window.addEventListener("message", function(t) {

    if ("e2w" == t.data.from){
        function getReactInstance(node) {
            const reactInstancePropName = Object.getOwnPropertyNames(node)
                .find(function(node) {
                    return node.startsWith('__reactInternalInstance$');
                });
            const propVal = node[reactInstancePropName];
            return propVal === null ?
                null : (propVal.return ? (propVal._debugOwner ? propVal._debugOwner.stateNode : propVal.return.stateNode) : propVal._currentElement._owner._instance)
        }

        if ("addOtherPaymentOption" == t.data.subject) {

            const options = {
                bindCardAllowed: !0,
                subPaymentMethodList: [{
                    available: !0,
                    paymentMethodName: '...',
                    paymentGateway: 'ebaypay',
                }],
                needChangeCurrency: !1,
                needCpfInput: !1,
                pmtOpt: 'others',
                screen: 1,
                available: !0
            };
            const paymentMethodElement = document.querySelector('#main .payment-info .pay-method');
            const reactInstance = getReactInstance(paymentMethodElement);
            if (reactInstance) {
                reactInstance.selectPayMethod(options);
                reactInstance.confirmPay();
            }

        }
    }

});

const ebay_get_order_fulfillment = e2w_get_order_fulfillment;
//const ebay_get_order_tracking_code =  e2w_get_order_tracking_code;
const ebay_go_to_payall = e2w_go_to_payall;
const ebay_close_chrome_tab = e2w_close_chrome_tab;
const ebay_switch_to_chrome_tab = e2w_switch_to_chrome_tab;

