
chrome.webRequest.onCompleted.addListener(
    function (details) {
        chrome.storage.sync.set({respStatus: details.statusCode}, function () {

        });
    },
    {urls: [config.urls.item]},
    ["responseHeaders"]
);

chrome.webRequest.onCompleted.addListener(
    function(details) {
        chrome.storage.sync.set({ addressFields: !0 });
    },
    {urls: [config.urls.ajaxGetAddressFields, config.urls.ajaxGetAddressFieldsG]}
);

chrome.webRequest.onCompleted.addListener(
    function(details) {
        chrome.storage.sync.set({ addAddress: !0 });
    },
    {urls: [config.urls.ajaxAddAddress, config.urls.ajaxAddAddressG]}
);

chrome.webRequest.onCompleted.addListener(
    function(details) {
        setTimeout(() => {
            chrome.storage.sync.set({ addSellerMessage: !0 });
        }, 200)
    },
    {urls: [config.urls.ajaxAddSellerMessage, config.urls.ajaxAddSellerMessageG]}
);

chrome.webRequest.onCompleted.addListener(
    function(details) {
        chrome.storage.sync.set({ editShippingService: !0 });
    },
    {urls: [config.urls.ajaxEditShippingService, config.urls.ajaxEditShippingServiceG]}
);

chrome.tabs.onActivated.addListener(function (activeInfo) {

    var tab = chrome.tabs.get(activeInfo.tabId, function (tab) {

        if ( tab.url.includes('chrome://') ) {
            chrome.browserAction.setIcon({
                path: {
                    "19": "assets/icons/imageinfo-16-mono.png",
                    "38": "assets/icons/imageinfo-32-mono.png"
                }
            });
            return;
        }

        if (MAFunc.isEbayPage(tab.url)) {

            if (MAFunc.isEbayCatPage(tab.url)) {
                chrome.browserAction.setPopup({popup: "popups/category.html"});
            } else {
                chrome.browserAction.setPopup({"popup": "popups/default.html"});
            }

            chrome.browserAction.setIcon({
                path: {
                    "19": "assets/icons/imageinfo-16.png",
                    "38": "assets/icons/imageinfo-32.png"
                }
            });

            return;
        } else {
            MAFunc.injectMainJs(activeInfo.tabId).then(function (r) {

                if (r) {
                    chrome.browserAction.setIcon({
                        path: {
                            "19": "assets/icons/imageinfo-16.png",
                            "38": "assets/icons/imageinfo-32.png"
                        }
                    });
                } else {
                    chrome.browserAction.setPopup({popup: ""});

                    chrome.browserAction.setIcon({
                        path: {
                            "19": "assets/icons/imageinfo-16-mono.png",
                            "38": "assets/icons/imageinfo-32-mono.png"
                        }
                    });
                }
            }).catch(function(e){console.log(e.message)});

        }
    });
});

/*
chrome.tabs.onCreated.addListener(function (tab) {

});
*/

chrome.tabs.onUpdated.addListener(function (tabId, changeInfo, tab) {
   // if (!changeInfo.url) return; // URL did not change

    if ( changeInfo.url && changeInfo.url.includes('chrome://') ) {
        chrome.browserAction.setIcon({
            path: {
                "19": "assets/icons/imageinfo-16-mono.png",
                "38": "assets/icons/imageinfo-32-mono.png"
            }
        });
        return;
    }

    if (MAFunc.isEbayPage(tab.url)) {
        if (MAFunc.isEbayCatPage(tab.url)) {
            chrome.browserAction.setPopup({popup: "popups/category.html"});
        } else {
            chrome.browserAction.setPopup({"popup": "popups/default.html"});
        }

        chrome.browserAction.setIcon({
            path: {
                "19": "assets/icons/imageinfo-16.png",
                "38": "assets/icons/imageinfo-32.png"
            }
        });

        return;
    } else {
        MAFunc.injectMainJs(tabId).then(function (r) {
            if (r) {
                chrome.browserAction.setIcon({
                    path: {
                        "19": "assets/icons/imageinfo-16.png",
                        "38": "assets/icons/imageinfo-32.png"
                    }
                });
            } else {
                chrome.browserAction.setIcon({
                    path: {
                        "19": "assets/icons/imageinfo-16-mono.png",
                        "38": "assets/icons/imageinfo-32-mono.png"
                    }
                });

            }
        }).catch(function(e){console.log(e.message)});
    }

});

chrome.extension.onMessage.addListener(function (t, e, a) {

    chrome.browserAction.setBadgeText({text: ""});

    if (t.main_hostname !== undefined) {
        updateUrls(t.main_hostname);
    }

    switch (t.action) {

        case config.actions.E_CONTENT_CHECK_PRODUCTS_IMPORTED:

            var ext_options;

            var checkProductsImportedPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: ext_options.api_key + config.api.checkProductsImported,
                    method: "POST",
                    params: e,
                    isForm: !0,
                    isAjax: !0
                })
            }

            var checkProductsImported = function (i, t) {
                var n = {id: i.join()};
                checkProductsImportedPromise(n).then(function (d) {

                    var p = {
                        "name": config.actions.E_CONTENT_CHECK_PRODUCTS_IMPORTED,
                        "products": d.data.products,
                        "status": 'OK',
                    };
                    chrome.tabs.sendMessage(e.tab.id, p);
                }).catch(function (g) {

                    if (g.responseText == '') {
                        g.responseText = "Can't connect to your store using this key.";
                    }

                    var p = {
                        "name": config.actions.E_CONTENT_CHECK_PRODUCTS_IMPORTED,
                        "status": "error",
                        "status_text": g.responseText
                    }
                    chrome.tabs.sendMessage(e.tab.id, p);
                })

            }

            config.get_ext_options(function (data) {
                ext_options = data;

                if (ext_options.api_key) {
                    checkProductsImported(t.ids, a);
                } else {
                    var p = {
                        "name": config.actions.E_CONTENT_CHECK_PRODUCTS_IMPORTED,
                        "status": "error",
                        "status_text": "Can`t find Active store"
                    }
                    chrome.tabs.sendMessage(e.tab.id, p);
                }

            });
            break;

        case config.actions.E_CONTENT_CLEAR_ORDER_DATA:

            chrome.storage.sync.set({
                orderId: !1,
                orderItems: !1,
                orderNumber: !1,
                shopName: !1,
                currentProduct: 0,
                orderData: !1,
                defaultShipping: config.defaultShippingSettings.shippingOption,
                note: !1,
                cartLoaded: !1,
                formFilled: 0,
                countrySet: 0,
                createdAt: !1,

            }, function () {

            });
            break;

        case config.actions.E_CONTENT_ORDER_FULFILLMENT_QUEUE:

            config.get_ext_options(function (data) {
                ext_options = data;

                if (ext_options.api_key !== false) {

                    var n = t.data;

                    chrome.storage.sync.get({
                        orderData: !1,
                        currentProduct: 0,
                        orderNumber: !1,
                        ebayTab: !1,
                        createdAt: 0
                    }, function (o) {

                        switch (typeof n) {
                            case 'undefined':
                                n = o.orderData;
                                break;
                            case 'object':
                                if (Object.keys({}).length !== 0) {
                                    n = o.orderData;
                                }
                                break;
                        }

                        if (typeof n.storeurl !== 'undefined' && !ext_options.api_key.includes(n.storeurl) ) {
                            chrome.storage.sync.set({maTab: e.tab}, function () {
                                sendOrderFulfillmentStatus(2);
                            });
                        } else {

                            if (o.currentProduct < 1 && (!o.createdAt || (o.createdAt && (Date.now() - o.createdAt <= 720 * 1000)))) {

                                openOrCreateTab(o.ebayTab.id, config.urls.ebayLink)
                                    .then(function (tab) {
                                        initDataStorage(n, function () {
                                            chrome.storage.sync.set({
                                                maTab: e.tab,
                                                ebayTab: tab,
                                                cartEmpty: !1,
                                            }, function () {
                                                orderFulfillment(tab);
                                            });
                                        });
                                    });

                            } else {
                                orderFulfillment(o.ebayTab);
                            }
                        }

                    });

                } else {
                    chrome.storage.sync.set({maTab: e.tab}, function () {
                        sendOrderFulfillmentStatus(1);
                    });
                }
            });

            break;

        case config.actions.E_CONTENT_ORDER_FULFILLMENT_STATUS_RESPONSE:

            sendOrderFulfillmentStatus(t.stage, t.param);
            break;

        case config.actions.E_CONTENT_ORDER_TRACKING_CODE_REQUEST:

            var n = t.data;

            var GetOrderDetailsPage = function (id) {
                return (0, get_xhr_promise)({
                    url: config.urls.orderInfo.replace("{1}", id).replace("{2}", 1 + Math.floor(Math.random() * 16)),
                    method: "GET",
                    params: null,
                    isForm: !0,
                    isAjax: !0
                })
            }

            var checkNextEl = function (id) {
                return new Promise(function (resolve, reject) {
                    GetOrderDetailsPage(id)
                        .then(function (d) {
                            resolve({data: d, order_id: id});
                        })
                        .catch(function (s) {
                            reject({order_id: id})
                        });
                });
            }

            var parseTrackingCodes = function (html) {
                var track_codes = [];
                $(html).find(".logistics-num").each(function () {
                    track_codes.push($(this).text().replace(/(\r\n|\n|\r)/gm, ""));
                });
                return track_codes;
            }

            var checkExistOrderNumber = function (html, order_id) {
                if ($(html).find(':contains("' + order_id + '")').length > 0) return true
                return false;
            }

            var checkLoginPage = function (html) {
                if ($(html).find("#signInField").length > 0) return true
                return false;
            }

            var checkNoAuthPage = function (html) {
                if ($(html).find(".ui-unusual-no-authorization").length > 0) return true
                return false;
            }

            checkNextEl(n)
                .then(function (d) {

                    var response = d.data, codes = [], s_code = 200;

                    if (checkLoginPage(response.responseText)) s_code = 401;
                    else {
                        if (!checkNoAuthPage(response.responseText)) {

                            if (checkExistOrderNumber(response.responseText, n)) codes = parseTrackingCodes(response.responseText);
                            else s_code = 403;
                        } else s_code = 404;
                    }

                    chrome.tabs.sendMessage(e.tab.id, {
                        source: "ma",
                        type: config.actions.E_CONTENT_ORDER_TRACKING_CODE_RESPONSE,
                        data: {index: d.index, el: d.el, tracking_codes: codes, status_code: s_code}
                    });

                })
                .catch(function (c) {

                    var response = c.message, s_code = 500;

                    chrome.tabs.sendMessage(e.tab.id, {
                        source: "ma",
                        type: config.actions.E_CONTENT_ORDER_TRACKING_CODE_RESPONSE,
                        data: {index: e.index, el: e.el, tracking_codes: [], status_code: s_code}
                    });
                });
            break;

        case config.actions.E_CONTENT_ORDER_FULFILLMENT_PAYALL_REQUEST:

            chrome.storage.sync.get({
                ebayTab: !1
            }, function (o) {

                var ta = true;

                if (o.ebayTab !== !1) {

                    function b() {
                        if (chrome.runtime.lastError) {

                            chrome.tabs.create({
                                "url": config.urls.ebayPayAllLink,
                                "active": ta
                            }, function (tab) {
                                chrome.storage.sync.set({ebayTab: tab}, function () {
                                });
                            });
                        } else {
                            // Tab exists
                            chrome.tabs.update(o.ebayTab.id, {
                                "url": config.urls.ebayPayAllLink,
                                "active": ta
                            }, function (tab) {

                            });
                        }
                    }

                    chrome.tabs.get(o.ebayTab.id, b);
                } else {
                    chrome.tabs.create({
                        "url": config.urls.ebayPayAllLink,
                        "active": ta
                    }, function (tab) {
                        chrome.storage.sync.set({ebayTab: tab}, function () {
                        });
                    });
                }

            });
            break;

        case config.actions.E_CONTENT_ORDER_FULFILLMENT_TO_CART:
            toCart(e.tab);
            break;

        case config.actions.E_CONTENT_ORDER_FULFILLMENT_RESPONSE:

            chrome.storage.sync.get({
                maTab: !1,
                orderId: !1
            }, function (o) {
                var ext_options;

                var getUpdateOrderInAppPromise = function (e) {
                    return (0, get_xhr_promise)({
                        url: ext_options.api_key + config.api.orderSync,
                        method: "POST",
                        params: e,
                        isForm: !0,
                        isAjax: !0
                    })
                }

                var UpdateOrderInApp = function (i, ext_i, t) {

                    var n = {id: i, external_id: ext_i};
                    getUpdateOrderInAppPromise(n)
                        .then(function (d) {
                            var p = {
                                id: n.id,
                                external_id: n.external_id,
                                status: 'OK'
                            };
                            t(p);
                        })
                        .catch(function (e) {
                            var v_status_text = e.data ? e.data.error : e.statusText,
                                p = {
                                    status: 'error',
                                    id: n.id,
                                    external_id: n.external_id,
                                    status_text: v_status_text
                                };

                            console.log("eBay2Woo Chrome extension can`t update the Woocommerce Order"), t(p);
                        })
                }

                config.get_ext_options(function (data) {
                    ext_options = data;
                    UpdateOrderInApp(o.orderId, t.id, a);
                })

            });
            return true;
            break;

        case config.actions.E_CONTENT_SET_EBAY_COOKIE:

            for (var i = 0; i < t.cookie_array.length; i += 1) {
                var cookie = t.cookie_array[i];
                chrome.cookies.set({
                    "name": cookie.name,
                    "url": config.urls.ebayLink,
                    "domain": cookie.params.domain,
                    "path": cookie.params.path,
                    "value": cookie.value
                }, function (cookie) {

                    var p = {'reqId': t.reqId};
                    a(p);
                });
            }
            return true;
            break;

        case config.actions.E_CONTENT_GET_PRODUCT_INFO:

            var ext_options;
            chrome.browserAction.setBadgeBackgroundColor({color: '#1ea8cf'});
            chrome.browserAction.setBadgeText({text: "GET"});

            config.get_ext_options(function (data) {
                ext_options = data;

                if (ext_options.api_key) {
                    var getLoadProductHtmlPromise = function (e) {
                        return (0, get_xhr_promise)({
                            url: e.url,
                            method: "GET"
                        });
                    }

                    var getSettingsPromise = function (e) {

                        return (0, get_xhr_promise)({
                            url: ext_options.api_key + config.api.getSettings,
                            method: "POST",
                            params: e,
                            isForm: !0,
                            isAjax: !0
                        })
                    }

                    var getProductInfo = function (e, i, t) {

                        var r = this,
                            u = config.urls.ebayLink + '/itm/' + e.id;
                        //    u = 'https://www.aliexpress.com/item/' + e.id + ".html";
                        n = {url: u, reqId: i};


                        getLoadProductHtmlPromise(n)
                            .then(function (d) {

                                var l = mainPanel.getEbayRunParamsFromHTML(d.responseText);

                                if (l !== false) {
                                    var send_result = function(p){
                                        chrome.browserAction.setBadgeText({text: ""});
                                        t(p);
                                    }

                                    var p = {
                                        status: 'ok',
                                        reqId: n.reqId,
                                        data: l,
                                        error_msg: ''
                                    };
                                    send_result(p);

                                   /* if ( typeof e.reviews == "undefined"){
                                        var p = {status: 'ok', reqId: n.reqId, data: l, error_msg: ''};
                                        send_result(p);
                                    }
                                    else {
                                        getReviewsPromise(JSON.parse(l)).then(function(resp){

                                            html = resp.responseText;

                                            var p = {status: 'ok', reqId: n.reqId, data: {main:l, reviews_html:html}, error_msg: ''};
                                            send_result(p);

                                     });
                                 }*/

                                } else {
                                    chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                                    chrome.browserAction.setBadgeText({text: "ERROR"});

                                    var p = {
                                        status: 'error',
                                        reqId: n.reqId,
                                        data: '',
                                        error_msg: 'Can`t Load Product Info. No runParams found'
                                    };
                                    t(p);
                                }

                            })
                            .catch(function (e) {
                                chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                                chrome.browserAction.setBadgeText({text: "ERROR"});

                                var p = {
                                    status: 'error',
                                    reqId: n.reqId,
                                    data: '',
                                    error_msg: e.status + ' ' + e.responseText
                                };
                                t(p);
                            });
                    }

                    getSettingsPromise().then(function (d) {

                        if (typeof d.data.settings.e2w_chrome_ext_import !== "undefined" && d.data.settings.e2w_chrome_ext_import === !1){

                            var p = {
                                status: 'ok',
                                reqId: i,
                                data: '',
                                error_msg: ''
                            };
                            chrome.browserAction.setBadgeText({text: ""});

                            a(p);
                        }

                        if (typeof t.params['curr'] == "undefined" || typeof t.params['locale'] == "undefined") {

                            if ( typeof d.data == "undefined" ||
                                typeof d.data.settings.e2w_import_locale == "undefined" ||
                                typeof d.data.settings.e2w_local_currency == "undefined" ) {

                                chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                                chrome.browserAction.setBadgeText({text: "ERROR"});

                                var p = {
                                    status: 'error',
                                    reqId: i,
                                    data: '',
                                    error_msg: 'No currency and/or locale in the settings'
                                };
                                a(p);

                            }

                            t.params['locale'] = d.data.settings.e2w_import_locale;
                            t.params['curr'] = d.data.settings.e2w_local_currency;
                        }

                        site = "glo";

                        if (typeof config.locale_site_map[t.params.locale] !== "undefined") {
                            site = config.locale_site_map[t.params.locale];
                        }

                        chrome.cookies.set({
                            "name": "aep_usuc_f",
                            "url": config.urls.ebayLink,
                            "domain": config.urls.domain,
                            "path": "/",
                            "value": "site=" + site + "&c_tp=" + t.params.curr + "&b_locale=" + t.params.locale

                        }, function (cookie) {

                            chrome.cookies.set({
                                "name": "aep_usuc_f",
                                "url": config.urls.ebayLink,
                                "domain": config.urls.domain,
                                "path": "/",
                                "value": "site=" + site + "&c_tp=" + t.params.curr + "&b_locale=" + t.params.locale
                            }, function (cookie2) {
                                getProductInfo(t.params, t.reqId, a);
                            });

                        });
                    })
                } else {
                    chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                    chrome.browserAction.setBadgeText({text: "ERROR"});
                    var p = {
                        status: 'error',
                        reqId: i,
                        data: '',
                        error_msg: 'Can`t find Active store'
                    };
                    a(p);

                }
            })

            return true;
            break;

        case config.actions.E_CONTENT_GET_PRODUCT_HTML:

            chrome.browserAction.setBadgeBackgroundColor({color: '#1ea8cf'});
            chrome.browserAction.setBadgeText({text: "GET"});

            var getLoadProductHtmlPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: e.url,
                    method: "GET"
                });
            }

            var getProductHtml = function (e, i, t) {
                var r = this,
                    n = {url: e, reqId: i};
                getLoadProductHtmlPromise(n)
                    .then(function (d) {
                        var p = {url: n.url, reqId: n.reqId, html: d.responseText};

                        chrome.browserAction.setBadgeText({text: ""});

                        t(p);

                    })
                    .catch(function (e) {
                        chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                        chrome.browserAction.setBadgeText({text: "ERROR"});

                        console.log("eBay2Woo Chrome extension can`t load the Product html.");
                        t(e);
                    })
            }

            getProductHtml(t.url, t.reqId, a);

            return true;
            break;

        case config.actions.E_GET_PRODUCTS_SHIPPING_INFO:

            var n = t.options,
                o = t.productIds;
            this.shippingInfo.getByIds(n, o, function (v) {
                chrome.tabs.sendMessage(e.tab.id, {"name": config.actions.E_GET_PRODUCTS_SHIPPING_INFO, "data": v})
            });
            break;

        case config.actions.E_CONTENT_DELETE_PRODUCT_FROM_APP:

            var ext_options;
            var getDeleteProductFromAppPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: ext_options.api_key + config.api.productDelete,
                    method: "POST",
                    params: e,
                    isForm: !0,
                    isAjax: !0
                });
            }

            var DeleteProductFromApp = function (i, t) {
                var n = {id: i};
                getDeleteProductFromAppPromise(n)
                    .then(function (d) {
                        var p = {id: n.id, status: 'OK'};
                        t(p);
                    })
                    .catch(function (e) {
                        401 !== e.status && console.log("Product deleted" + n.id), t(e)
                    });
            }

            config.get_ext_options(function (data) {
                ext_options = data;
                DeleteProductFromApp(t.id, a);
            });

            return true;
            break;

        case config.actions.E_CONTENT_TEST_CONNECTION:

            var getSyncSettingsPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: ext_options.api_key + config.api.getSettings,
                    method: "POST",
                    params: e,
                    isForm: !0,
                    isAjax: !0
                })
            }

            var syncSettings = function () {

                return (0, getSyncSettingsPromise)().then(function (d) {
                    /*
                    return new Promise(function(r) {

                        typeof d.data !== "undefined" &&
                        typeof d.data.settings !== "undefined", console.log(d.data.settings),

                        chrome.storage.sync.set({

                            shippingOption: d.data.settings.a2w_fulfillment_prefship,
                            shippingCountry: d.data.settings.a2w_aliship_shipto,
                            shippingCurrency: d.data.settings.a2w_local_currency

                        }, function() {
                            return r();
                        })
                    })
                     */
                }).catch(function(e){

                });
            }

            config.get_ext_options(function (data) {
                ext_options = data;

                syncSettings().then(function () {
                        var p = {status: 'ok'};
                        a(p);
                    })
                    .catch(function (e) {

                        if (e.responseText == '') {
                            e.responseText = "Can't connect to your store using this key.";
                        }
                        var p = {status: 'error', error: e.responseText};
                        a(p);
                    });
            });

            return true;
            break;

        case config.actions.E_CONTENT_SET_POPUP:

            chrome.browserAction.setPopup({popup: t.popup});
            // chrome.pageAction.setPopup({popup: t.popup});
            break;

        case config.actions.E_SYNC_PRODUCT_LIST:

            var ext_options;
            var getSyncProductListPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: ext_options.api_key + config.api.importList,
                    method: "POST",
                    params: e,
                    isForm: !0,
                    isAjax: !0
                })
            }

            var syncProductList = function (t) {
                getSyncProductListPromise()
                    .then(function (d) {
                        var p = {products: d.data.products, status: 'OK', success: true};
                        t(p);
                    }).catch(function (e) {
                    console.log("API: syncProductList error"), e.success = false, console.log(e), t(e)
                });
            }

            config.get_ext_options(function (data) {
                ext_options = data;
                syncProductList(a);
            })

            return true;
            break;

        case config.actions.E_CONTENT_PUSH_PRODUCT_TO_APP:

            chrome.browserAction.setBadgeBackgroundColor({color: '#1ea8cf'});
            chrome.browserAction.setBadgeText({text: "SEND"});

            var ext_options;
            var getPushProductPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: ext_options.api_key + config.api.productImport,
                    method: "POST",
                    params: e,
                    isForm: !0,
                    isAjax: !0
                });
            }

            var pushProduct = function (e, i, th, pmn, pmx, ttl, cur, apd, t) {
                var r = this,
                    n = {
                        url: e, id: i, thumb: th,
                        price_min: pmn,
                        price_max: pmx,
                        title: ttl,
                        currency: cur,
                        apd: apd
                    };

                getPushProductPromise(n).then(function (d) {
                    var p = '';

                    if (d.data && d.data.status == 'ok') {
                        chrome.browserAction.setBadgeText({text: ""});

                        p = {url: n.url, id: n.id, status: 'OK'};
                        console.log("eBay2Woo Chrome extension pushed the Product " + n.id + " sucessfully");
                    } else {

                        chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                        chrome.browserAction.setBadgeText({text: "ERROR"});

                        if ( d.data && d.data.status && d.data.warning) {
                            p = {url: n.url, id: n.id, status: d.data.status, status_text: d.data.warning};
                        } else {
                            p = {url: n.url, id: n.id, status: 'error', status_text: 'can`t import product ' + n.id};
                        }

                    }
                    t(p);
                }).catch(function (e) {

                    chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                    chrome.browserAction.setBadgeText({text: "ERROR"});

                    if (e.resultType === "timeout") {
                        console.log("eBay2Woo Chrome extension: Product " + n.id + " pushed timeout");
                        setTimeout(function () {
                            pushProduct(n.url, n.id, n.thumb, n.price_min, n.price_max, n.title, n.currency, n.apd, t);
                        }, 3000);
                    } else {

                        var p = {
                            url: n.url,
                            id: n.id,
                            th: n.thumb,
                            pmn: n.price_min,
                            pmx: n.price_max,
                            ttl: n.title,
                            cur: n.currency,
                            apd: apd,
                            status: e.status,
                            status_text: e.data && e.data.error ? e.data.error : e.statusText
                        };

                        if (ext_options.api_key == !1) {
                            p.status_text = "Can`t find Active store";
                        }
                        console.log("eBay2Woo Chrome extension can`t pushed the Product " + n.id + "."), t(p);
                    }

                });

            }

            config.get_ext_options(function (data) {
                ext_options = data;
                pushProduct(t.url, t.id, t.thumb, t.price_min,
                    t.price_max, t.title, t.currency, t.apd, a);
            })

            return true;
            break;

        case config.actions.E_GET_AND_PUSH_PRODUCT_HTML_TO_APP:

            chrome.browserAction.setBadgeBackgroundColor({color: '#1ea8cf'});
            chrome.browserAction.setBadgeText({text: "GET"});

            var ext_options;
            var getLoadProductHtmlPromise = function (e) {
                return (0, get_xhr_promise)({
                    url: e.url,
                    method: "GET"
                });
            }

            var getProductHtml = function (e, i, th, pmn, pmx, ttl, cur, t) {

                var r = this,
                    n = {
                        url: e, id: i, thumb: th,
                        price_min: pmn,
                        price_max: pmx,
                        title: ttl,
                        currency: cur
                    };

                getLoadProductHtmlPromise(n).then(function (d) {

                    chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                    chrome.browserAction.setBadgeText({text: "ERROR"});

                    var opts = ext_options /*config.defaultShippingSettings*/,
                        o = n.id;

                    shippingInfo.getByIds(opts, [o], function (e) {
                        var p = {url: n.url, id: n.id, html: d.responseText, shipdata: e.freight};

                        pushProductHtml(p.id, p.url, p.html, p.shipdata, t);
                    });

                }).catch(function (e) {
                    chrome.browserAction.setBadgeBackgroundColor({color: '#fb0153'});
                    chrome.browserAction.setBadgeText({text: "ERROR"});

                    var p = {url: n.url, id: n.id, status: e.status};
                    console.log("eBay2Woo Chrome extension can`t laod the Product html."), t(p);
                });
            }

            config.get_ext_options(function (data) {
                ext_options = data;
                getProductHtml(t.url, t.id, t.thumb, t.price_min,
                    t.price_max, t.title, t.currency, a);
            })

            return true;
            break;

        case config.actions.E_CONTENT_PUSH_PRODUCT_TO_APP:

            chrome.tabs.create({'url': "/options.html"});
            break;

        case config.actions.E_CONTENT_CLOSE_CHROME_TAB_REQUEST:

            chrome.storage.sync.get({
                ebayTab: !1
            }, function (o) {
                if (o.ebayTab !== !1) {
                    var i = o.ebayTab.id;
                    chrome.tabs.get(i, function () {
                        if (!chrome.runtime.lastError) {
                            chrome.tabs.remove(i, function () {
                            });
                        }
                    });
                }
            });
            break;

        case config.actions.E_CONTENT_SWITCH_TO_CHROME_TAB_REQUEST:

            chrome.storage.sync.get({
                ebayTab: !1
            }, function (o) {
                // Tab exists
                if (o.ebayTab) {
                    chrome.tabs.update(o.ebayTab.id, {
                        "active": true
                    }, function (tab) {

                    });
                }
            });
            break;

        case config.actions.E_CONTENT_TEST_REQUEST:

            break;

        case config.actions.E_CONTENT_UPDATE_TAB_URL:

            chrome.storage.sync.get({
                ebayTab: !1
            }, function (o) {
                chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
                    chrome.tabs.update(o.ebayTab.id, {url: t.url});
                });
            });
            break;

        //todo: maybe delete it?
        case config.actions.E_CONTENT_GET_COUNTRIES:

            chrome.webRequest.onBeforeSendHeaders.addListener(
                function (details) {
                    for (var n in details.requestHeaders) {
                        var nm = details.requestHeaders[n].name.toLowerCase();

                        if ( nm == "sec-fetch-mode" || nm == "sec-fetch-site" || nm == "origin" || nm == "referer" ) {
                            details.requestHeaders.splice(n, 1);
                        }
                    }

                //    details.requestHeaders.push({name: 'Host', value: 'ilogisticsaddress.aliexpress.com'});
                //    details.requestHeaders.push({name: 'Referer', value: 'https://shoppingcart.aliexpress.com'});
                    details.requestHeaders.push({name: 'Host', value:  config.urls.host});
                    details.requestHeaders.push({name: 'Referer', value:  config.urls.cart});
                    details.requestHeaders.push({name: 'Pragma', value: 'no-cache'});
                    details.requestHeaders.push({name: 'Cache-Control', value: 'no-cache'});


                    return {requestHeaders: details.requestHeaders};
                },
                {urls: [config.urls.queryCountries + "*"]},
                ["blocking", "requestHeaders", "extraHeaders"]
            );


            fetch(config.urls.queryCountries + "?" + t.params_str, {
                    "credentials": "omit",
                    "method": "GET",
                    "headers": {
                        "Accept": "*/*",
                        "Accept-Language": "en-US,en;q=0.5",
                    },
                }).then(function (e) {
                    return e.text()
                }).then(function (e) {
                    var r = e.replace(/"p?c":"[\d|\w]*",/g, "");
                    /*  r = r.replace("__jp3(", "")*/
                    r = r.replace("__zoro_request_4(", "")

                        .slice(0, -1);
                    var n = JSON.parse(r);

                    if (n && n.addressList) return n.addressList

                    return [];

                }).then(function (e) {
                    var p = {status: 'OK', success: true, data: e};

                    a(p);
                }).catch(function (e) {
                    var p = {status: 'ERROR', success: false, data: []};
                    a(p);
                });

            return true;
            break;

        case config.actions.E_CONTENT_GET_SHIPPING_METHOD:

            chrome.webRequest.onBeforeSendHeaders.addListener(
                function (details) {

                    for (var n in details.requestHeaders) {
                        var nm = details.requestHeaders[n].name.toLowerCase();

                        if ( nm == "sec-fetch-mode" || nm == "sec-fetch-site" || nm == "origin" || nm == "referer" ) {
                            details.requestHeaders.splice(n, 1);
                        }
                    }

                //    details.requestHeaders.push({name: 'Origin', value: 'https://aliexpress.com'});
                //    details.requestHeaders.push({name: 'Host', value: 'https://aliexpress.com'});
                //    details.requestHeaders.push({name: 'Referer', value: 'https://aliexpress.com'});
                    details.requestHeaders.push({name: 'Origin', value: config.urls.ebayLink});
                    details.requestHeaders.push({name: 'Host', value: config.urls.host});
                    details.requestHeaders.push({name: 'Referer', value: config.urls.ebayLink});
                    details.requestHeaders.push({name: 'Pragma', value: 'no-cache'});
                    details.requestHeaders.push({name: 'Cache-Control', value: 'no-cache'});

                    return {requestHeaders: details.requestHeaders};
                },
                {urls: [config.urls.v2GetShippingMethods + "*"]},
                ["blocking", "requestHeaders", "extraHeaders"]
            );


            fetch(config.urls.v2GetShippingMethods + "?" + t.params_str, {
                    credentials: "include",
                    method: "GET",
                    mode: 'cors'
                }).then(function (e) {

                    if (200 === e.status){
                        var p = {status: 'OK', success: true, data: e.json()};
                    } else {
                        var p = {status: 'ERROR', success: false};
                    }

                    a(p);
                }).catch(function (e) {
                    var p = {status: 'ERROR', success: false};
                    a(p);
                });

            return true;
            break;

        case config.actions.E_CONTENT_ADD_PRODUCT_TO_CART:

            chrome.webRequest.onBeforeSendHeaders.addListener(function (details) {
                for (var n in details.requestHeaders) {
                    var nm = details.requestHeaders[n].name.toLowerCase();

                    if ( nm == "sec-fetch-mode" || nm == "sec-fetch-site" || nm == "origin" || nm == "referer" ) {
                        details.requestHeaders.splice(n, 1);
                    }
                }

                details.requestHeaders.push({name: 'Origin', value: config.urls.ebayLink});
                details.requestHeaders.push({name: 'Host', value: config.urls.ebayPaymentHost});
                details.requestHeaders.push({name: 'Referer', value: t.refererUrl});
                details.requestHeaders.push({name: 'Pragma', value: 'no-cache'});
                details.requestHeaders.push({name: 'Cache-Control', value: 'no-cache'});

            },
            {urls: [config.urls.addToCart + "*"]},
            ["blocking", "requestHeaders", "extraHeaders"]);

            fetch(t.addCartUrl, {
                    credentials: "include",
                    method: "GET",
                    mode: 'cors'
                }).then(function (e) {

                    if (200 === e.status){
                        var p = {status: 'OK', success: true};
                    } else {
                        var p = {status: 'ERROR', success: false};
                    }

                    a(p);
                }).catch(function (e) {
                    var p = {status: 'ERROR', success: false};
                    a(p);
                });

            return true;
            break;

        case config.actions.E_CONTENT_SET_ADDRESS:

            function queryCountryData(c) {

                var param = {
                    country: c,
                    features: JSON.stringify({
                        ruPassport: "taxNumber",
                        locale: "en_US"
                    }),
                    shipcompany: 'CAINIAO_STANDARD',
                    useLocalAddress: true,
                    callback:"__zoro_request_4"
                }

                chrome.webRequest.onBeforeSendHeaders.addListener(
                    function (details) {

                        for (var n in details.requestHeaders) {
                            var nm = details.requestHeaders[n].name.toLowerCase();

                            if ( nm == "sec-fetch-mode" || nm == "sec-fetch-site" || nm == "origin" || nm == "referer" ) {
                                   details.requestHeaders.splice(n, 1);
                               }
                        }

                    //    details.requestHeaders.push({name: 'Host', value: 'ilogisticsaddress.aliexpress.com'});
                    //    details.requestHeaders.push({name: 'Referer', value: 'https://shoppingcart.aliexpress.com'});
                        details.requestHeaders.push({name: 'Host', value: config.urls.host});
                        details.requestHeaders.push({name: 'Referer', value: config.urls.cart});
                        details.requestHeaders.push({name: 'Pragma', value: 'no-cache'});
                        details.requestHeaders.push({name: 'Cache-Control', value: 'no-cache'});


                        return {requestHeaders: details.requestHeaders};
                    },
                    {urls: [config.urls.queryCountries + "*"/*, config.urls.ordersDetail , config.urls.ajaxSaveOrUpdateBuyerAddress + "*"*/]},
                    ["blocking", "requestHeaders", "extraHeaders"]
                );

                return fetch(config.urls.queryCountries + "?" + MAFunc.serialize(param), {
                    "credentials": "omit",
                    "headers": {
                        "Accept": "*/*",
                        "Accept-Language": "en-US,en;q=0.5",
                    },
                    "method": "GET",

                }).then(function (e) {
                    return e.text()
                }).then(function (e) {
                    var r = e.replace(/"p?c":"[\d|\w]*",/g, "");
                  /*  r = r.replace("__jp3(", "")*/
                    r = r.replace("__zoro_request_4(", "").slice(0, -1);
                    var n = JSON.parse(r);

                    if (n && n.addressList) return n.addressList

                    return [];

                }).then(function(e){

                    return new Promise(function(n) {
                        chrome.storage.sync.set({orderAddressList: e},
                            function () {
                                return n(e);
                            });
                    });
                })

            }

            function selectFromTheList(d, e) {
                var t = e.map(function (e) {
                        return e.n.toLowerCase()
                    }),
                    r = t.find(function (el) {
                        return el === d.orderData.region
                    }),
                    n = null;

                if (r) {
                    var o = e.find(function (e) {
                        return e.n === r
                    });

                    if (o && o.children) {

                        n = o.children.find(o.children.map(function (e) {
                            return e.n
                        }), d.orderData.city), n || "undefined" === t.find(function (e) {
                            return "Other" === e.n
                        }) || (r = "Other")
                    }
                } else "undefined" !== t.find(function (e) {
                    return "Other" === e.n
                }) && (r = "Other");
                return {
                    region: r,
                    city: n
                }
            }

            function tlc(v) {
                return v ? v.toLowerCase() : v;
            }

            function tuc(v) {
                return v ? v.toUpperCase() : v;
            }

            function cfl(s){
                return s ? s.charAt(0).toUpperCase() + s.slice(1) : s;
            }

            function cew(s){
                return s.replace(/\w\S*/g, function(txt){
                    return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
                });
            }

            function f11(i) {

                var param = {
                    itemIds: i,
                    objectId: '',
                    aeOrderFrom: 'main_shopcart',
                    shippingCompany: '',
                    promiseId: '',
                    itemCondition: '',
                    skuAttr: '',
                    quantity: '',
                    pageQuantity: '',
                    selectedAddressId: '',
                    changeAddress: '',
                    provinceCode: '',
                    cityCode: '',
                    splitOrder: false,
                    splitOrderIds: '',
                    splitOrderNum: '',
                    splitOrderShopCartIds: '',
                    promotionMode: '',
                    groupBuyId: '',
                    umidToken: '',
                    ua: ''
                }

                return fetch(config.urls.ordersDetail, {
                    "credentials": "include",
                    "headers": {
                        "Accept": "application/json, text/plain, */*",
                        "Accept-Language": "en-US,en;q=0.5",
                        "Content-Type": "application/x-www-form-urlencoded"
                    },
                //    "referrer": 'https://shoppingcart.aliexpress.com',
                    "referrer":  config.urls.cart,
                    "body": MAFunc.serialize(param),
                    "method": "POST",
                    "mode": "cors"
                }).then(response =>
                    response.json().then(data => ({
                            data: data,
                            status: response.status
                        })
                    )
                )
            }

            function f12(t, d, i) {

                function en(s){
                    if (s == "") return s
                    else return s.replace(' ','+');
                }

                function r(e) {
                    var n = e.countryRegion, i = e.zip;
                    return "PL" === n && (i = i.replace("-", "")), "none" === i && (i = ""), i
                }

                r1 = config.phoneCountryCodes[d.orderData.countryRegion] || "";

                if ("" === d.orderData.mobile) d.orderData.mobile = "000000";

                if ( d.orderData.countryRegion != "BR") d.cpf = '';

                var param = {
                    _csrf_token_: t,
                    contactPerson: d.orderData.contactName,
                    phone: '',
                    mobileNo: d.orderData.mobile,
                    phoneArea: '',
                    phoneCountry: r1,
                    address: d.orderData.address1,
                    address2: d.orderData.address2,
                    country: d.orderData.countryRegion,
                    countryName : '', /*todo*/
                    isDefault: '',
                    province: cew(d.orderData.region),
                    provinceInLocalLanguage: '',
                    city: cfl(d.orderData.city),
                    cityInLocalLanguage: '',
                    zip: r(d.orderData),
                    email: '',
                    fullName: '',
                    passportNo: '',
                    encryptPassportNo: '',
                    passportNoDate: '',
                    passportOrganization: '',
                    taxNumber: '',
                    cpf: d.cpf,
                    encryptCpf: '', /*todo*/
                    needUpdate: '',
                    hint: '',
                    hasSelfPickUpPoint: '',
                    selfPickUpPointId: '',
                    selfPickUpPointHint: '',
                    addressType: '',
                    houseAddressId: '',
                    expressCode: '',
                    selected: true,
                    features: JSON.stringify({
                        locale: "en_US",
                        ruPassport: "taxNumber"
                    }),
                    shipcompany: config.defaultShippingSettings.shippingOption,
                    useLocalAddress: true
                }

                if (i) {
                    param['id'] = i, param['shippingMethodId'] = i;
                }

                return fetch(config.urls.ajaxSaveOrUpdateBuyerAddress, {
                        "credentials": "include",
                        "headers": {
                            "Accept": "application/json, text/plain, */*",
                            "Content-Type": "application/x-www-form-urlencoded",
                        //    "Origin": "https://shoppingcart.aliexpress.com",
                        //    "Referer": "https://shoppingcart.aliexpress.com/orders.htm?aeOrderFrom=main_shopcart",
                            "Origin":  config.urls.cart,
                            "Referer":  config.urls.cart +"/orders.htm?aeOrderFrom=main_shopcart",
                            "sec-fetch-mode": "cors"
                        },
                    //    "referrer": "https://shoppingcart.aliexpress.com/orders.htm?aeOrderFrom=main_shopcart",
                        "referrer":  config.urls.cart +"/orders.htm?aeOrderFrom=main_shopcart",
                        "body": MAFunc.serialize(param),
                        "method": "POST",
                        "mode": "cors",
                        "TE": "Trailers"
                    })
                    .then(res => res.json())
            }

            function f13(d) {
                return queryCountryData(d.orderData.countryRegion).then(function (e) {
                    o = !1;
                    if (e && e.length > 0) {
                        var j = selectFromTheList(d, e);
                        j.region && (o = j.region.indexOf(d.orderData.region) < 0, d.orderData.region = j.region), j.city && (o = j.city.indexOf(d.orderData.city) < 0, d.orderData.city = j.city);
                    } else {
                        if (d.orderData.region == '') d.orderData.region = "Other";
                        if (d.orderData.city == '') d.orderData.city = "Other";
                    }

                    return d;
                });
            }

            f11(t.ids).then(function (e) {

                var d = false;

                if (e.status == 200 && e.data.shipping.selectedAddressList !== null) {
                    d = e.data.shipping.selectedAddressList[0].shippingMethodId;
                }

                t.data.orderData.countryRegion = tuc(t.data.orderData.countryRegion);
                t.data.orderData.region = tlc(t.data.orderData.region);
                t.data.orderData.city = tlc(t.data.orderData.city);

                f13(t.data).then(function (data) {

                    f12(t.token, data, d).then(function (response) {

                        if (response && !response.success && response.fieldErrorMessageList) {

                            error_msgs = [];

                            for (var h in response.fieldErrorMessageList) {
                                var j = response.fieldErrorMessageList[h];
                                error_msgs.push('field: ' + j.name + ' message: ' + j.errorMessage);
                            }

                            var pr = {status: 'ERROR', success: false, messages: error_msgs};

                            return a(pr);

                        }

                        var pr = {status: 'OK', success: true};

                        return a(pr);
                    });

                }).catch(function (e) {
                    return a(!1);
                })

            }).catch(function (e) {
                return a(!1);
            });

            return true;
            break;

        case config.actions.E_CONTENT_SWITCH_TO_PLUGIN_TAB_REQUEST:

            chrome.storage.sync.get({
                maTab: !1
            }, function (o) {
                // Tab exists
                chrome.tabs.update(o.maTab.id, {
                    "active": true
                }, function (tab) {

                });
            });
            break;

        default:
            console.error('action is not found');

    }

});


