function clearCartAndContinue() {
    MAStatusBar.add("Clearing cart...");

    var o = MAPromises;

    chrome.storage.sync.set({
        continueAfterRefresh: !0
    }, function() {

        if (null === document.querySelector('.empty-cart .start-shop[data-test-id="start-shopping"]')) {
            o.waitEl('.call-to-action[data-test-id="cta-top"]').then(function(e){
                if (e) {
                    var remove_buttons = $('button.faux-link[data-test-id="cart-remove-item"]');

                    if (remove_buttons.length) {

                        var do_remove = function(arr, ind, func){
                            if (ind == arr.length){
                                return func();
                            }

                            var el = arr[ind];
                            o.clickBtn(el).then(function(){
                                setTimeout(() => {
                                    do_remove(arr, ind+1, function(){
                                        orderProducts();
                                    });
                                }, 400);
                            });
                        }

                        do_remove(remove_buttons, 0);

                    } else {
                        orderProducts();
                    }
                } else {
                    orderProducts();
                }
            })
            .catch(function(e){
                MAStatusBar.remove();
                MAStatusBar.add("Some issues occur during the clearing cart process!");
            });
        } else {
            orderProducts();
        }
    });
}

function orderProducts() {

    MAOrder.sendStatus({'stage':51}, function(){
        MAFunc.goToPluginTab();
    });

    chrome.storage.sync.set({
        continueAfterRefresh: !1,
        chrmact: !1,
        cartEmpty: !0
    }, function() {
        chrome.storage.sync.get({
            orderData: !1,
            currentProduct: 0
        }, function(e) {
            if (e.orderData !== !1) {
                var r = JSON.parse(e.orderData),
                    t = r.products[e.currentProduct];

                chrome.runtime.sendMessage({
                    action: config.actions.E_CONTENT_UPDATE_TAB_URL,
                    url: t.url
                })

            }
        });
    });
}

function submitCart() {
    MAStatusBar.add("Submitting cart...");

    function u(e) {

        return new Promise(function(n, t) {
            var w=0, i = setInterval(function() {
               if ($(e).length){

                    clearInterval(i);

                    setTimeout(function() {
                        return n(!0)
                    }, 300);
               }

               w+=1;

               if (w > 10){
                   clearInterval(i);
                   return t(!1);
               }

            }, 300)
        })
    }

    chrome.storage.sync.remove('chrmact');

    u('.call-to-action').then(function(res){
        if (res){
            var guest = document.querySelector('#gh-ug a');

            if (guest !== null && guest.getAttribute('href') !== null && guest.getAttribute('href').indexOf(config.urls.ebaySingIn) === 0) {
                MAOrder.sendStatus({'stage': 46}, function () {
                    MAFunc.goToPluginTab();
                });

                chrome.storage.sync.set({ cartLoaded: !0 });

                MAStatusBar.remove();
                MAStatusBar.add("Please log into your eBay account");
                MAPromises.clickBtn('.call-to-action');
            } else {
                chrome.storage.sync.get({
                    orderId: 0,
                    orderNumber: "",
                    shopName: "",
                    orderData: !1,
                    defaultShipping: "",
                    note: "",
                    formFilled: 0,
                    countrySet: 0,
                    createdAt: 0
                 }, function(e) {

                    MAOrder.sendStatus({'stage':52}, function(){
                        MAFunc.goToPluginTab();
                    });

                    chrome.storage.sync.set({
                        cartLoaded: !0
                    }, function () {
                        MAStatusBar.remove();
                        MAPromises.clickBtn('.call-to-action');
                    });

                    return void 0;
                });
            }

        } else {
            console.log('call-to-action not found');
            /*
            MAOrder.sendStatus({'stage':52},function(){
                MAFunc.goToPluginTab();
            });
            */
        }
    }).catch(function(ex){
    //    console.log(ex.message);
        chrome.storage.sync.get({
            cartLoaded: !1,
        }, function(e) {
            if (e.cartLoaded !== !1){
                MAStatusBar.remove();
                MAStatusBar.add("Please use 'Add to Cart' button instead of 'Buy Now'. Please take this tip into account and fulfill this order again.");
            }
        });

    })

}

function cartAction() {

    chrome.storage.sync.get({
        chrmact: !1
    }, function(es) {

        if (es.chrmact === 'clearCart') {
            /*
            chrome.extension.sendMessage({
                action: config.actions.E_CONTENT_SWITCH_TO_CHROME_TAB_REQUEST,
            //    data: d
            });
            */
            clearCartAndContinue();
        } else if (es.chrmact === 'submitCart') {
            submitCart();
        } else {
            chrome.storage.sync.get({
                continueAfterRefresh: !1
            }, function(e) {
                1 == e.continueAfterRefresh && orderProducts()
            })
        }
    });

}

jQuery(document).ready(function($) {
    $('body').append(MAMessages.statusBar());

    chrome.storage.sync.get({
        orderId: 0,
        orderNumber: "",
        shopName: "",
        orderData: !1,
        defaultShipping: config.defaultShippingSettings.shippingOption,
        note: "",
        formFilled: 0,
        countrySet: 0,
        createdAt: 0
    }, function(e) {

        if (e.orderData == !1) return;

        if (Date.now() - e.createdAt > 720 * 1000) { //12 min
            MAStatusBar.remove();
            MAStatusBar.add("We found the unfinished order fulfillment process and remove it.");

            MAOrder.clear();

            MAOrder.sendStatus({'stage':11},function(){
                MAFunc.goToPluginTab();
            });

            return;
        }

        cartAction();
   });

});