
function start_init_checkout() {

    function waitEl(e) {
        return new Promise((n, t) => {
            var r = setInterval(() => {
                if (document.querySelector(e)) return clearInterval(r), n(!0)
            }, 300)
        })
    }

    function getBlock(elem) {
        return new Promise((res, rej) => {
            let el = elem;
            var tik = setInterval(() => {
                if (document.querySelector(el)) {
                    clearInterval(tik);
                    res(!0);
                }
            }, 300);

            setTimeout(() => {
                clearInterval(tik), rej(!1);
            }, 5000);
        });
    }

    function setInputValue(in_elem, value) {
        let lastValue = in_elem.value;
        in_elem.value = value;
        let event = new Event('input', { bubbles: true });
        let event2 = new Event('blur', { bubbles: true });

        event.simulated = true;
        event2.simulated = true;

        let tracker = in_elem._valueTracker;
        if (tracker) {
            tracker.setValue(lastValue);
        }
        in_elem.dispatchEvent(event);
        in_elem.dispatchEvent(event2);
    }

    function setElemClick(in_elem) {
        let event = new Event('click', { bubbles: true });
        in_elem.dispatchEvent(event);
    }

    function getFirstUpper(w) {
        w = w.toUpperCase();
        return w.charAt(0).toUpperCase() + w.slice(1);
    }

    function fillShip(form_el, order_data) {
        return new Promise((res, rej) => {

            setTimeout(() => {
                setInputValue(form_el.querySelector('#firstName'), order_data.first_name);
                setInputValue(form_el.querySelector('#lastName'), order_data.last_name);
                setInputValue(form_el.querySelector('#addressLine1'), order_data.address1);
                setInputValue(form_el.querySelector('#addressLine2'), order_data.address2);
                setInputValue(form_el.querySelector('#city'), order_data.city.trim());
            }, 500);

            setTimeout(() => {
                if (order_data.region) {
                    var elem = form_el.querySelector('#stateOrProvince');

                    if (elem) {
                        switch (elem.tagName) {
                            case 'SELECT':
                                let province = order_data.region.toLowerCase();
                                let items = elem.querySelectorAll('option');

                                for (let i = 0, len = items.length; i < len; i++) {

                                    if (items[i].textContent.toLowerCase() === province && items[i].value !== '') {
                                        items[i].selected = true;
                                        break;
                                    }
                                }
                                break;
                            case 'INPUT':
                                setInputValue(elem, order_data.region);
                                break;
                        }
                    }
                }

                setInputValue(form_el.querySelector('#postalCode'), order_data.zip.replace("-", "") );
                setInputValue(form_el.querySelector('#phoneNumber'), order_data.mobile);

                if (order_data.mobile_code !== ''
                    && form_el.querySelector('#phoneCountryCode .dialCode').textContent !== order_data.mobile_code) {
                    form_el.querySelector('select[name=phoneCountryCode]').value = order_data.countryRegion;
                }

                return res(!0);
            }, 1000);
        });
    }

    function fillData(form_el, order_data) {

        return new Promise((res, rej) => {
            var startUpdate = false;

            var timerFill = setInterval(() => {
                chrome.storage.sync.get({
                    addressFields: !1
                }, (o) => {

                    if (o.addressFields && !startUpdate) {
                        startUpdate = true;

                        setTimeout(() => {

                            fillShip(form_el, order_data).then(r => {
                                let tmp = form_el.querySelector('#firstName');
                                if (tmp.value === '') {
                                    tmp.value = order_data.first_name;
                                }
                                tmp = form_el.querySelector('#lastName');
                                if (tmp.value === '') {
                                    tmp.value = order_data.last_name;
                                }
                                tmp = form_el.querySelector('#addressLine1');
                                if (tmp.value === '') {
                                    tmp.value = order_data.address1;
                                }
                                tmp = form_el.querySelector('#addressLine2');
                                if (tmp.value === '') {
                                    tmp.value = order_data.address2;
                                }

                                clear(true);
                            });
                        }, 400)

                    }
                });
            }, 300);

            function clear(r) {
                chrome.storage.sync.remove('addressFields');
                clearInterval(timerFill);
                r ? res(!0) : res(!1);
            }

            form_el.querySelector('#country').value = order_data.countryRegion;

            let eventChange = new Event("change", { bubbles: true });
            eventChange.simulated = true;

            var elem = document.querySelector('#country');

            elem.dispatchEvent(eventChange);

            setTimeout(() => {
                if (!startUpdate) {
                    chrome.storage.sync.remove('addressFields');
                    clearInterval(timerFill);

                    fillShip(form_el, order_data).then(r => {
                        r ? res(!0) : res(!1)
                    });
                }
            }, 7000);
        });
    }

    function fillAddressFields(order_data) {

        return new Promise((res, rej) => {
            let address_form = document.querySelector('form[name="address-form"]');

            if (address_form) {

                setTimeout(() => {

                    fillData(address_form, order_data).then((r) => { r ? res(!0) : res(!1) });

                }, 1000);

            } else {
                res(!1);
            }
        });
    }

    function addAddressQuery() {
        return new Promise((res, rej) => {
            var timerFill = setInterval(() => {
                chrome.storage.sync.get({
                    addAddress: !1
                }, (o) => {
                    if (o.addAddress) {
                        chrome.storage.sync.remove('addAddress');
                        clearInterval(timerFill);
                        return res(!0);
                    }
                });
            }, 300);

            setTimeout(() => {
                chrome.storage.sync.remove('addAddress');
                clearInterval(timerFill);
                res(!1);
            }, 5000);
        });
    }

    function startWaitCorrectAddress(order_data) {

        new Promise((res, rej) => {
            var timerFill = setInterval(() => {
                chrome.storage.sync.get({
                    addAddress: !1
                }, (o) => {
                    if (o.addAddress) {
                        chrome.storage.sync.remove('addAddress');
                        clearInterval(timerFill);
                        return res(!0);
                    }
                });
            }, 300);

            setTimeout(() => {
                clearInterval(timerFill);
                return res(!1);
            }, 1000 * 60 * 3);
        }).then((res) => {

            MAStatusBar.remove();
            MAStatusBar.add("Continue filling customer details...");
            MAOrder.sendStatus({'stage': 513}, () => MAFunc.goToPluginTab());

            return existErrorAddress(order_data);

        }).then((res) => {
            if (res) {
                if (order_data.defaultShipping !== undefined || order_data.defaultShipping !== '') {
                    return setDefaultShipping(order_data.defaultShipping);
                }
            }
            return res;
        }).then((res) => {
            if (res) {
                return waitTimeSec(.5);
            }
            return res;
        }).then((res) => {
            if (res) {
                if (order_data.note !== undefined && order_data.note !== '') {
                    return setNotes(order_data.note);
                }
            }
            return res;

        }).then((res) => {
            if (res) {
                return waitTimeSec(1);
            }
        }).then((res) => {
            if (res) {
                // TODO: payment CreditCart PayPal
                goToPayPal();
            }
        })
        .catch(ex => console.log(ex.message));
    }

    function existErrorAddress(order_data) {
        return new Promise((res, rej) => {

            setTimeout(() => {

                let address_form = document.querySelector('form[name="address-form"]');

                if (address_form && address_form.querySelectorAll('.error-message').length > 0) {

                    if (address_form.querySelector('#firstName').value === '') {
                        address_form.querySelector('#firstName').value = order_data.first_name;
                    }
                    if (address_form.querySelector('#lastName').value === '') {
                        address_form.querySelector('#lastName').value = order_data.last_name;
                    }
                    if (address_form.querySelector('#addressLine1').value === '') {
                        address_form.querySelector('#addressLine1').value = order_data.address1;
                    }
                    if (address_form.querySelector('#addressLine2').value === '') {
                        address_form.querySelector('#addressLine2').value = order_data.address2;
                    }

                    if (address_form.querySelectorAll('.error-message').length > 0) {
                        MAStatusBar.remove();
                        MAStatusBar.add("Enter your shipping details");

                        MAOrder.sendStatus({'stage': 512}, () => MAFunc.goToPluginTab());

                        startWaitCorrectAddress(order_data);

                        return res(!1);
                    } else {
                        // duplicate insert data empty error
                        setElemClick(document.querySelector('form[name="address-form"] button[type="submit"]'));
                        return res(!0);
                    }

                } else {
                    let addresses = document.querySelector('.address-form');

                    if (addresses) {

                        let btns_use_address = addresses.querySelectorAll('.address-action[data-test-id="SHIPPING_ADDRESS_RECOMMENDATION_SUBMIT"]');

                        if (btns_use_address.length === 0) {
                            btns_use_address = addresses.querySelector('.form-action.ADD_ADDRESS_SUBMIT');

                            if (btns_use_address && btns_use_address.querySelector('button[data-test-id="ADD_ADDRESS_SUBMIT"]')) {
                                // btn add
                                setElemClick(btns_use_address.querySelector('button[data-test-id="ADD_ADDRESS_SUBMIT"]'));
                            }

                            return res(!0);
                        } else {
                            // 0 - btn provided
                            // 1 - btn recommend address
                            if (btns_use_address[1] !== undefined &&  btns_use_address[1].querySelector('button').length > 0) {
                                setElemClick(btns_use_address[1].querySelector('button'));
                            }
                            return res(!0);
                        }

                        return res(!1);
                    } else {
                        return res(!0);
                    }
                }

            }, 1000);

        });
    }

    async function setNoteItem(i, note) {

        return await new Promise(res => {

            let sbi = document.querySelector('.seller-buckets').querySelectorAll('.seller-bucket')[i];

            let link_open = sbi.querySelector('a[data-test-id="MESSAGE_TO_SELLER_OPEN"]');

            if (link_open !== null) {

            //    setElemClick(sbi.querySelector('a[data-test-id="MESSAGE_TO_SELLER_OPEN"]'));
                link_open.click();

                setTimeout(() => {
                    let textarea = sbi.querySelector('textarea[data-test-id="MESSAGE_TO_SELLER_TEXT_AREA"]');

                    if (textarea) {
                        setInputValue(textarea, note);

                        setTimeout(() => {
                            document.querySelector('.message-to-seller').querySelector('button[data-test-id="MESSAGE_TO_SELLER_SUBMIT"]').click();
                        }, 300);
                    }

                }, 400);

                var timer = setInterval(() => {
                    chrome.storage.sync.get({
                        addSellerMessage: !1
                    }, (o) => {
                        if (o.addSellerMessage) {
                            clear();
                        }
                    });
                }, 300);

                function clear() {
                    clearInterval(timer);
                    chrome.storage.sync.set({ addSellerMessage: !1 });
                    chrome.storage.sync.remove('addSellerMessage');

                    setTimeout(() => {
                        res(!0);
                    }, 300);
                }

            } else {
                res(!1);
            }
        });
    }

    function setNotes(note) {
        let sb = document.querySelector('.seller-buckets');
        if (sb) {
            let sb_list = sb.querySelectorAll('.seller-bucket');

            if (sb_list.length > 0) {

                return new Promise(res => {
                    let q = Promise.resolve();
                    for (let i = 0, cnt = sb_list.length; i < cnt; i++) {
                        q = q.then(async () => {await setNoteItem(i, note)});
                    }

                    q.then((rr) => {
                        res(!0);
                    });
                });

            } else {
                return !0;
            }
        } else {
            return !0;
        }
    }

    function equalsIgnoreCase(srt1, str2) {
        return srt1.toLowerCase().replaceAll(' ', '-') === str2.toLowerCase().replaceAll(' ', '-');
    }

    async function setDefaultShippingItem(i, defaultShipping) {

        return await new Promise(res => {
            let sg = document.querySelectorAll('.logistics-type-group')[i].querySelector('.logistics-service-group');
            let wait_return = !1;
            if (sg) {
                let sb_list = sg.querySelectorAll('.field.logistic-service-summary-block');
                if (sb_list.length > 1) {
                    // more 1 shipping
                    let service_shipping_name;
                    for (let i = 0, cnt = sb_list.length; i < cnt; i++) {
                        service_shipping_name = sb_list[i].querySelector('.service-display').querySelector('.service-display-line-3').textContent;

                        if (equalsIgnoreCase(defaultShipping, service_shipping_name)) {

                            if (!sb_list[i].querySelector('.radio__control').checked) {
                                sb_list[i].querySelector('label.field__label').click();
                                wait_return = !0;
                            }
                            break;
                        }
                    }

                }
            }

            if (!wait_return) {
                res(!0);
            } else {
                var timer = setInterval(() => {
                    chrome.storage.sync.get({
                        editShippingService: !1
                    }, (o) => {
                        if (o.editShippingService) {
                            clear();
                        }
                    });
                }, 200);

                function clear() {
                    clearInterval(timer);
                    chrome.storage.sync.set({ editShippingService: !1 });
                    chrome.storage.sync.remove('editShippingService');

                    setTimeout(() => {
                        res(!0);
                    }, 500);
                }
            }

        });
    }

    function setDefaultShipping(defaultShipping) {
        let ltg = document.querySelectorAll('.logistics-type-group');

        if (ltg.length > 0) {
            return new Promise(res => {
                let q = Promise.resolve();
                for (let i = 0, cnt = ltg.length; i < cnt; i++) {
                    q = q.then(async () => {await setDefaultShippingItem(i, defaultShipping)});
                }

                q.then((rr) => {
                    res(!0);
                });
            });

        } else {
            return !0;
        }
    }

    function waitTimeSec(sec) {
        return new Promise(res => {
            setTimeout(() => {
                res(!0);
            }, sec * 1000);
        });
    }

    function goToPayPal() {
        let payment_methods = document.querySelector('#payment-selection-fieldset').querySelectorAll('input[name="radio-group-paymentMethod"]:not(:disabled)');
        MAStatusBar.remove();

        if (payment_methods.length > 1) {

            MAStatusBar.add("Please choose the payment method and pay for this order.");
            MAOrder.sendStatus({'stage': 44}, () => MAFunc.goToPluginTab());
        } else {
            /*
            chrome.extension.sendMessage({
                action: config.actions.E_CONTENT_SWITCH_TO_CHROME_TAB_REQUEST
            });
            */
            setTimeout(() => {
                setElemClick(payment_methods[0].parentNode.parentNode);
            }, 300);

            MAStatusBar.add("Done! Please pay for this order.");
            MAOrder.sendStatus({'stage': 57});
        //    MAOrder.sendStatus({'stage': 57}, () => MAFunc.goToPluginTab());
            MAOrder.clear();

        }
    }

    function checkStyle() {
        let ma_stat = document.getElementById('ma-status-bar-container');

        if (ma_stat) {
            if (getComputedStyle(ma_stat)['position'] !== 'fixed') {
                let link = document.createElement('link');
                link.href = chrome.extension.getURL('assets/stylesheets/css/app.css');
                link.type = 'text/css';
                link.rel = 'stylesheet';
                document.getElementsByTagName('head')[0].appendChild(link);
            }
        }
    }

    document.body.classList.add("ma");
    document.body.classList.add("ma-checkout");

    $(document.body).append(MAMessages.statusBar());

    setTimeout(() => {
        checkStyle();
    }, 2000);

    chrome.storage.sync.set({
        addressFields: !1,
        addAddress: !1,
        addSellerMessage: !1,
        editShippingService: !1
    });

    chrome.storage.sync.get({
        orderId: 0,
        orderNumber: "",
        shopName: "",
        orderData: !1,
        defaultShipping: "",
        note: "",
        formFilled: 0,
        countrySet: 0,
        createdAt: 0,
        autopay: !1,
        cpf: "",
        awaitingpay : !0,
        cartLoaded: !1,
    }, (e) => {

        if (e.orderData == !1)
            return;

        if (Date.now() - e.createdAt > 720 * 1000) { //12 min
            chrome.runtime.sendMessage({
                action: config.actions.E_CONTENT_CLEAR_ORDER_DATA
            });

            return;
        }

        if ($(document.location).attr('href').indexOf('pay.ebay.') > 0
            && $(document.location).attr('href').indexOf('/rgxo') > 0) {
            // guest order
            let order_data = JSON.parse(e.orderData);

            chrome.storage.sync.remove('cartLoaded');

            MAOrder.sendStatus({'stage': 513}, () => MAFunc.goToPluginTab());
            MAStatusBar.remove();
            MAStatusBar.add("Filling custom details...");

            fillAddressFields(order_data).then((r) => {
                return new Promise((res, rej) => {

                    setTimeout(() => {
                        setElemClick(document.querySelector('form[name="address-form"] button[type="submit"]'));
                    }, 400);

                    setTimeout(() => {
                        res(!0);
                    }, 1000);
                });

            }).then((res) => {
                return addAddressQuery();
            }).then((res) => {
                return existErrorAddress(order_data);
            }).then((res) => {
                if (res) {
                    return setNotes(order_data.note);
                }
                return res;
            }).then((res) => {
                if (res) {
                    goToPayPal();
                } else {
                    // guest - email is empty
                    MAOrder.sendStatus({'stage': 512}, () => MAFunc.goToPluginTab());

                    MAStatusBar.remove();
                    MAStatusBar.add("Please fill in customer shipping details");
                }

            }).catch(ex => console.log(ex.message));

        } else {

            // authorize order
            if (e.cartLoaded !== !0) return;

            chrome.storage.sync.remove('cartLoaded');

            let order_data = JSON.parse(e.orderData);

            MAOrder.sendStatus({'stage': 513}, () => MAFunc.goToPluginTab());
            MAStatusBar.remove();
            MAStatusBar.add("Filling custom details...");

            waitEl('.module.shipping-address .shipping-address-summary').then(() => {new Promise((res, rej) => {

                    let shipping_address = document.querySelector('.module.shipping-address .shipping-address-summary');

                    if (shipping_address) {
                        var tik = setInterval(() => {
                            let change_btn = shipping_address.querySelector('a[data-test-id="EXPAND_SHIPPING_ADDRESSES"]');
                            change_btn && (clearInterval(tik), change_btn.click(), res());
                        }, 400);

                        setTimeout(() => {
                            clearInterval(tik), rej(!1);
                        }, 5000);
                    }
                })
            }).then((r) => {
                return getBlock('.module.shipping-address .address-list--other-options');
            }).then((res) => {

                let add_shipping_address = document.querySelector('.module.shipping-address .address-list--other-options');

                if (add_shipping_address) {
                    let add_btn = add_shipping_address.querySelector('a[data-test-id="GET_ADDRESS_FORM"]');
                    if (add_btn) {
                        setElemClick(add_btn);
                        return true;
                    }
                }
                return false;
            }).then((res) => {
                if (res === true) {
                    return getBlock('form[name="address-form"]');
                } else {
                    return false;
                }
            }).then((res) => {
                if (res) {
                    return fillAddressFields(order_data);
                } else {
                    MAOrder.sendStatus({'stage': 512}, () => MAFunc.goToPluginTab());
                    MAStatusBar.remove();
                    MAStatusBar.add("Please fill in customer shipping details");
                    return false;
                }
            }).then((res) => {
                return getBlock('form[name="address-form"] button[type="submit"]');
            }).then((r) => {;
                return new Promise((res, rej) => {

                    setTimeout(() => {
                        setElemClick(document.querySelector('form[name="address-form"] button[type="submit"]'));
                    }, 400);

                    setTimeout(() => {
                        res(!0);
                    }, 1000);
                });
            }).then((res) => {
                return addAddressQuery();

            }).then((res) => {
                return existErrorAddress(order_data);

            }).then((res) => {
                if (res) {
                    if (order_data.defaultShipping !== undefined || order_data.defaultShipping !== '') {
                        return setDefaultShipping(order_data.defaultShipping);
                    }
                }
                return res;

            }).then((res) => {
                if (res) {
                    return waitTimeSec(.5);
                }
                return res;
            }).then((res) => {
                if (res) {
                    if (order_data.note !== undefined && order_data.note !== '') {
                        return setNotes(order_data.note);
                    }
                }
                return res;

            }).then((res) => {
                if (res) {
                    return waitTimeSec(1);
                }
            }).then((res) => {
                if (res) {
                    // TODO: payment CreditCart PayPal
                    goToPayPal();
                }
            })
            .catch(ex => console.log(ex.message));
        }

    });
}

if (window.top === window.window) {
    jQuery(document).ready(function($) {
        start_init_checkout();
    });
}