//MAFunc.setPopup("popups/default.html");

(function() {
    if (window.hasRun === true)
        return true;  // Will ultimately be passed back to executeScript
    window.hasRun = true;

    chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {
        if (msg.name === config.actions.E_CHECK_MAIN_CONTENT_IS_INCLUDED) {
            sendResponse({status: "yes"});
        }
    });

    if (!MAFunc.isScriptAlreadyIncluded("assets/js/scripts/ma_api.js")){
        var s = document.createElement('script');
        s.src = chrome.extension.getURL("assets/js/scripts/ma_api.js");
        document.documentElement.appendChild(s);
    }

    if (window.location.href == config.urls.ebayMaintain){
        chrome.storage.sync.get({
            orderData: !1
        }, function (o) {
            if (o.orderData !== !1){
                setTimeout(function(){
                    history.back();
                }, 1000);
            }
        });

    }

    var requestHtml = function(t, r) {
        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_GET_PRODUCT_HTML,
            url: t,
            reqId: r
        }, function(e) {

            var responseData = {"html":e.html , "reqId":e.reqId};
            var fetchResponse = new CustomEvent(config.actions.E_WEB_GET_PRODUCT_HTML_RESPONSE, {"detail":responseData});
            document.dispatchEvent(fetchResponse);

        });
    };

    var requestProductInfo = function(t, r) {
        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_GET_PRODUCT_INFO,
            params: t,
            reqId: r
        }, function(e) {

            var responseData = {"status":e.status, "data":e.data, "error_msg": e.error_msg, "reqId":e.reqId};
            var fetchResponse = new CustomEvent(config.actions.E_WEB_GET_PRODUCT_INFO_RESPONSE, {"detail":responseData});
            document.dispatchEvent(fetchResponse);

        });
    };

    /*
    chrome.extension.onMessage.addListener(function(t, e, n) {
        "get_order_fulfillment_response" == t.type &&
            document.dispatchEvent( new CustomEvent('get_order_fulfillment_response', {"detail":t.data}) );

    });*/



    document.addEventListener(config.actions.E_WEB_SET_EBAY_COOKIE_REQUEST, function(event) {
        var data = event.detail;
        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_SET_EBAY_COOKIE,
            cookie_array: data.cookie_array,
            reqId: data.reqId
        }, function(e) {

            var responseData = {"reqId":e.reqId};
            var fetchResponse = new CustomEvent(config.actions.E_WEB_SET_EBAY_COOKIE_RESPONSE, {"detail":responseData});
            document.dispatchEvent(fetchResponse);

       });
    });


    document.addEventListener(config.actions.E_WEB_GET_PRODUCT_HTML_REQUEST, function(event) {
        var data = event.detail;
        requestHtml(data.url, data.reqId);
    });


    document.addEventListener(config.actions.E_WEB_GET_PRODUCT_INFO_REQUEST, function(event) {
        var data = event.detail;
        MAProduct.requestProductInfo(data.params, data.reqId, function(e) {

            var responseData = {"status":e.status, "data":e.data, "error_msg": e.error_msg, "reqId":e.reqId};
            var fetchResponse = new CustomEvent(config.actions.E_WEB_GET_PRODUCT_INFO_RESPONSE, {"detail":responseData});
            document.dispatchEvent(fetchResponse);

        });
      //  requestProductInfo(data.params, data.reqId);
    });


    document.addEventListener(config.actions.E_WEB_ORDER_FULFILLMENT_REQUEST, function(event) {
       /*
        chrome.storage.sync.set({
            currentProduct: 0
        }, function(e) {*/

            var d = event.detail;

            if (chrome.extension['sendMessage'] !== undefined) {
                chrome.extension.sendMessage({
                    action: config.actions.E_CONTENT_ORDER_FULFILLMENT_QUEUE,
                    data: d
                });
            }
      /*  });*/

    });


    document.addEventListener(config.actions.E_WEB_ORDER_TRACKING_CODE_REQUEST, function(event) {
        var d = event.detail;
        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_ORDER_TRACKING_CODE_REQUEST,
            data: d
        });
    });


    chrome.extension.onMessage.addListener(function(t, e, n) {
        config.actions.E_CONTENT_ORDER_TRACKING_CODE_RESPONSE == t.type &&
            document.dispatchEvent( new CustomEvent(config.actions.E_WEB_ORDER_TRACKING_CODE_RESPONSE, {"detail":t.data}) );

    });

    chrome.extension.onMessage.addListener(function(t, e, n) {
        config.actions.E_CONTENT_ORDER_FULFILLMENT_STATUS_RESPONSE == t.type &&
        document.dispatchEvent( new CustomEvent(config.actions.E_WEB_ORDER_FULFILLMENT_STATUS_RESPONSE, {"detail":t.data}) );
    });

    document.addEventListener(config.actions.E_WEB_ORDER_FULFILLMENT_PAYALL_REQUEST, function(event) {
        var d = event.detail;
        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_ORDER_FULFILLMENT_PAYALL_REQUEST,
            data: d
        });
    });

    document.addEventListener(config.actions.E_WEB_CLOSE_CHROME_TAB_REQUEST, function(event) {
        var d = event.detail;

        if (chrome.extension['sendMessage'] !== undefined) {
             chrome.extension.sendMessage({
                action: config.actions.E_CONTENT_CLOSE_CHROME_TAB_REQUEST,
                data: d
            });
        }
    });

    document.addEventListener(config.actions.E_WEB_SWITCH_TO_CHROME_TAB_REQUEST, function(event) {
        var d = event.detail;
        chrome.extension.sendMessage({
            action: config.actions.E_CONTENT_SWITCH_TO_CHROME_TAB_REQUEST,
            data: d
        });
    });

})(); // <-- Invoke function. The return value is passed back to executeScript